GDAL

- Main Page
- Related Pages
- Classes
- Files
- Download
- Issue Tracker

- File List
- File Members

Classes | Macros | Typedefs | Enumerations | Functions
gdal.h File Reference

Public (C callable) GDAL entry points. More...

Go to the source code of this file.

## Classes
struct | GDALRasterIOExtraArg
| Structure to pass extra arguments to RasterIO() method. More...
struct | GDAL_GCP
| Ground Control Point. More...
struct | GDALRPCInfo
| Strucutre to store Rational Polynomial Coefficients / Rigorous Projection Model. More...
struct | GDALColorEntry
| Color tuple. More...

## Macros
#define | INIT_RASTERIO_EXTRA_ARG(s)
| Macro to initialize an instance of GDALRasterIOExtraArg structure. More...
#define | GDALMD_AREA_OR_POINT "AREA_OR_POINT"
| Metadata item for dataset that indicates the spatial interpreation of a pixel.
#define | GDALMD_AOP_AREA "Area"
| Value for GDALMD_AREA_OR_POINT that indicates that a pixel represents an area.
#define | GDALMD_AOP_POINT "Point"
| Value for GDALMD_AREA_OR_POINT that indicates that a pixel represents a point.
#define | GDAL_DMD_LONGNAME "DMD_LONGNAME"
| Long name of the driver.
#define | GDAL_DMD_HELPTOPIC "DMD_HELPTOPIC"
| URL (relative to http://gdal.org/) to the help page of the driver.
#define | GDAL_DMD_MIMETYPE "DMD_MIMETYPE"
| MIME type handled by the driver. More...
#define | GDAL_DMD_EXTENSION "DMD_EXTENSION"
| Extension handled by the driver. More...
#define | GDAL_DMD_CONNECTION_PREFIX "DMD_CONNECTION_PREFIX"
| Connection prefix to provide as the file name of the open function. More...
#define | GDAL_DMD_EXTENSIONS "DMD_EXTENSIONS"
| List of (space separated) extensions handled by the driver. More...
#define | GDAL_DMD_CREATIONOPTIONLIST "DMD_CREATIONOPTIONLIST"
| XML snippet with creation options. More...
#define | GDAL_DMD_OPENOPTIONLIST "DMD_OPENOPTIONLIST"
| XML snippet with open options. More...
#define | GDAL_DMD_CREATIONDATATYPES "DMD_CREATIONDATATYPES"
| List of (space separated) raster data types support by the Create()/CreateCopy() API. More...
#define | GDAL_DMD_CREATIONFIELDDATATYPES "DMD_CREATIONFIELDDATATYPES"
| List of (space separated) vector field types support by the CreateField() API. More...
#define | GDAL_DMD_SUBDATASETS "DMD_SUBDATASETS"
| Capability set by a driver that exposes Subdatasets. More...
#define | GDAL_DCAP_OPEN "DCAP_OPEN"
| Capability set by a driver that implements the Open() API. More...
#define | GDAL_DCAP_CREATE "DCAP_CREATE"
| Capability set by a driver that implements the Create() API. More...
#define | GDAL_DCAP_CREATECOPY "DCAP_CREATECOPY"
| Capability set by a driver that implements the CreateCopy() API. More...
#define | GDAL_DCAP_VIRTUALIO "DCAP_VIRTUALIO"
| Capability set by a driver that can read/create datasets through the VSI*L API. More...
#define | GDAL_DCAP_RASTER "DCAP_RASTER"
| Capability set by a driver having raster capability. More...
#define | GDAL_DCAP_VECTOR "DCAP_VECTOR"
| Capability set by a driver having vector capability. More...
#define | GDAL_DCAP_GNM "DCAP_GNM"
| Capability set by a driver having vector capability. More...
#define | GDAL_DCAP_NOTNULL_FIELDS "DCAP_NOTNULL_FIELDS"
| Capability set by a driver that can create fields with NOT NULL constraint. More...
#define | GDAL_DCAP_DEFAULT_FIELDS "DCAP_DEFAULT_FIELDS"
| Capability set by a driver that can create fields with DEFAULT values. More...
#define | GDAL_DCAP_NOTNULL_GEOMFIELDS "DCAP_NOTNULL_GEOMFIELDS"
| Capability set by a driver that can create geometry fields with NOT NULL constraint. More...
#define | GDAL_OF_READONLY 0x00
| Open in read-only mode. More...
#define | GDAL_OF_UPDATE 0x01
| Open in update mode. More...
#define | GDAL_OF_ALL 0x00
| Allow raster and vector drivers to be used. More...
#define | GDAL_OF_RASTER 0x02
| Allow raster drivers to be used. More...
#define | GDAL_OF_VECTOR 0x04
| Allow vector drivers to be used. More...
#define | GDAL_OF_GNM 0x08
| Allow gnm drivers to be used. More...
#define | GDAL_OF_SHARED 0x20
| Open in shared mode. More...
#define | GDAL_OF_VERBOSE_ERROR 0x40
| Emit error message in case of failed open. More...
#define | GDAL_OF_INTERNAL 0x80
| Open as internal dataset. More...
#define | GDAL_OF_DEFAULT_BLOCK_ACCESS 0
| Let GDAL decide if a array-based or hashset-based storage strategy for cached blocks must be used. More...
#define | GDAL_OF_ARRAY_BLOCK_ACCESS 0x100
| Use a array-based storage strategy for cached blocks. More...
#define | GDAL_OF_HASHSET_BLOCK_ACCESS 0x200
| Use a hashset-based storage strategy for cached blocks. More...
#define | GDAL_DS_LAYER_CREATIONOPTIONLIST "DS_LAYER_CREATIONOPTIONLIST"
| Name of driver metadata item for layer creation option list.
#define | SRCVAL(papoSource, eSrcType, ii)
| SRCVAL - Macro which may be used by pixel functions to obtain a pixel from a source buffer. More...
#define | GMF_ALL_VALID 0x01
| Flag returned by GDALGetMaskFlags() to indicate that all pixels are valid.
#define | GMF_PER_DATASET 0x02
| Flag returned by GDALGetMaskFlags() to indicate that the mask band is valid for all bands.
#define | GMF_ALPHA 0x04
| Flag returned by GDALGetMaskFlags() to indicate that the mask band is an alpha band.
#define | GMF_NODATA 0x08
| Flag returned by GDALGetMaskFlags() to indicate that the mask band is computed from nodata values.
#define | GDAL_DATA_COVERAGE_STATUS_UNIMPLEMENTED 0x01
| Flag returned by GDALGetDataCoverageStatus() when the driver does not implement GetDataCoverageStatus(). More...
#define | GDAL_DATA_COVERAGE_STATUS_DATA 0x02
| Flag returned by GDALGetDataCoverageStatus() when there is (potentially) data in the queried window. More...
#define | GDAL_DATA_COVERAGE_STATUS_EMPTY 0x04
| Flag returned by GDALGetDataCoverageStatus() when there is nodata in the queried window. More...
#define | GDAL_CHECK_VERSION(pszCallingComponentName) GDALCheckVersion(GDAL_VERSION_MAJOR, GDAL_VERSION_MINOR, pszCallingComponentName)
| Helper macro for GDALCheckVersion() More...

## Typedefs
typedef void * | GDALMajorObjectH
| Opaque type used for the C bindings of the C++ GDALMajorObject class.
typedef void * | GDALDatasetH
| Opaque type used for the C bindings of the C++ GDALDataset class.
typedef void * | GDALRasterBandH
| Opaque type used for the C bindings of the C++ GDALRasterBand class.
typedef void * | GDALDriverH
| Opaque type used for the C bindings of the C++ GDALDriver class.
typedef void * | GDALColorTableH
| Opaque type used for the C bindings of the C++ GDALColorTable class.
typedef void * | GDALRasterAttributeTableH
| Opaque type used for the C bindings of the C++ GDALRasterAttributeTable class.
typedef void * | GDALAsyncReaderH
| Opaque type used for the C bindings of the C++ GDALAsyncReader class.
typedef GIntBig | GSpacing
| Type to express pixel, line or band spacing. More...
typedef CPLErr(* | GDALDerivedPixelFunc) (void **papoSources, int nSources, void *pData, int nBufXSize, int nBufYSize, GDALDataType eSrcType, GDALDataType eBufType, int nPixelSpace, int nLineSpace)
| Type of functions to pass to GDALAddDerivedBandPixelFunc. More...

## Enumerations
enum | GDALDataType { GDT_Unknown = 0, GDT_Byte = 1, GDT_UInt16 = 2, GDT_Int16 = 3, GDT_UInt32 = 4, GDT_Int32 = 5, GDT_Float32 = 6, GDT_Float64 = 7, GDT_CInt16 = 8, GDT_CInt32 = 9, GDT_CFloat32 = 10, GDT_CFloat64 = 11, GDT_TypeCount = 12 }
enum | GDALAsyncStatusType { GARIO_PENDING = 0, GARIO_UPDATE = 1, GARIO_ERROR = 2, GARIO_COMPLETE = 3, GARIO_TypeCount = 4 }
| status of the asynchronous stream
enum | GDALAccess { GA_ReadOnly = 0, GA_Update = 1 }
enum | GDALRWFlag { GF_Read = 0, GF_Write = 1 }
enum | GDALRIOResampleAlg { GRIORA_NearestNeighbour = 0, GRIORA_Bilinear = 1, GRIORA_Cubic = 2, GRIORA_CubicSpline = 3, GRIORA_Lanczos = 4, GRIORA_Average = 5, GRIORA_Mode = 6, GRIORA_Gauss = 7 }
| RasterIO() resampling method. More...
enum | GDALColorInterp { GCI_Undefined =0, GCI_GrayIndex =1, GCI_PaletteIndex =2, GCI_RedBand =3, GCI_GreenBand =4, GCI_BlueBand =5, GCI_AlphaBand =6, GCI_HueBand =7, GCI_SaturationBand =8, GCI_LightnessBand =9, GCI_CyanBand =10, GCI_MagentaBand =11, GCI_YellowBand =12, GCI_BlackBand =13, GCI_YCbCr_YBand =14, GCI_YCbCr_CbBand =15, GCI_YCbCr_CrBand =16, GCI_Max =16 }
enum | GDALPaletteInterp { GPI_Gray =0, GPI_RGB =1, GPI_CMYK =2, GPI_HLS =3 }
enum | GDALRATFieldType { GFT_Integer, GFT_Real, GFT_String }
| Field type of raster attribute table. More...
enum | GDALRATFieldUsage { GFU_Generic = 0, GFU_PixelCount = 1, GFU_Name = 2, GFU_Min = 3, GFU_Max = 4, GFU_MinMax = 5, GFU_Red = 6, GFU_Green = 7, GFU_Blue = 8, GFU_Alpha = 9, GFU_RedMin = 10, GFU_GreenMin = 11, GFU_BlueMin = 12, GFU_AlphaMin = 13, GFU_RedMax = 14, GFU_GreenMax = 15, GFU_BlueMax = 16, GFU_AlphaMax = 17, GFU_MaxCount }
| Field usage of raster attribute table. More...
enum | GDALTileOrganization { GTO_TIP, GTO_BIT, GTO_BSQ }
| ! Enumeration to describe the tile organization More...

## Functions
int | GDALGetDataTypeSize (GDALDataType)
| Get data type size in bits. More...
int | GDALGetDataTypeSizeBits (GDALDataType eDataType)
| Get data type size in bits. More...
int | GDALGetDataTypeSizeBytes (GDALDataType)
| Get data type size in bytes. More...
int | GDALDataTypeIsComplex (GDALDataType)
| Is data type complex? More...
const char * | GDALGetDataTypeName (GDALDataType)
| Get name of data type. More...
GDALDataType | GDALGetDataTypeByName (const char *)
| Get data type by symbolic name. More...
GDALDataType | GDALDataTypeUnion (GDALDataType, GDALDataType)
| Return the smallest data type that can fully express both input data types. More...
double | GDALAdjustValueToDataType (GDALDataType eDT, double dfValue, int *pbClamped, int *pbRounded)
| Adjust a value to the output data type. More...
GDALDataType | GDALGetNonComplexDataType (GDALDataType)
| Return the base data type for the specified input. More...
const char * | GDALGetAsyncStatusTypeName (GDALAsyncStatusType)
| Get name of AsyncStatus data type. More...
GDALAsyncStatusType | GDALGetAsyncStatusTypeByName (const char *)
| Get AsyncStatusType by symbolic name. More...
const char * | GDALGetColorInterpretationName (GDALColorInterp)
| Get name of color interpretation. More...
GDALColorInterp | GDALGetColorInterpretationByName (const char *pszName)
| Get color interpretation by symbolic name. More...
const char * | GDALGetPaletteInterpretationName (GDALPaletteInterp)
| Get name of palette interpretation. More...
void | GDALAllRegister (void)
| Register all known configured GDAL drivers. More...
GDALDatasetH | GDALCreate (GDALDriverH hDriver, const char *, int, int, int, GDALDataType, char **) CPL_WARN_UNUSED_RESULT
| Create a new dataset with this driver. More...
GDALDatasetH | GDALCreateCopy (GDALDriverH, const char *, GDALDatasetH, int, char **, GDALProgressFunc, void *) CPL_WARN_UNUSED_RESULT
| Create a copy of a dataset. More...
GDALDriverH | GDALIdentifyDriver (const char *pszFilename, char **papszFileList)
| Identify the driver that can open a raster file. More...
GDALDriverH | GDALIdentifyDriverEx (const char *pszFilename, unsigned int nIdentifyFlags, const char *const *papszAllowedDrivers, const char *const *papszFileList)
| Identify the driver that can open a raster file. More...
GDALDatasetH | GDALOpen (const char *pszFilename, GDALAccess eAccess) CPL_WARN_UNUSED_RESULT
| Open a raster file as a GDALDataset. More...
GDALDatasetH | GDALOpenShared (const char *, GDALAccess) CPL_WARN_UNUSED_RESULT
| Open a raster file as a GDALDataset. More...
GDALDatasetH | GDALOpenEx (const char *pszFilename, unsigned int nOpenFlags, const char *const *papszAllowedDrivers, const char *const *papszOpenOptions, const char *const *papszSiblingFiles) CPL_WARN_UNUSED_RESULT
| Open a raster or vector file as a GDALDataset. More...
int | GDALDumpOpenDatasets (FILE *)
| List open datasets. More...
GDALDriverH | GDALGetDriverByName (const char *)
| Fetch a driver based on the short name. More...
int | GDALGetDriverCount (void)
| Fetch the number of registered drivers. More...
GDALDriverH | GDALGetDriver (int)
| Fetch driver by index. More...
void | GDALDestroyDriver (GDALDriverH)
| Destroy a GDALDriver. More...
int | GDALRegisterDriver (GDALDriverH)
| Register a driver for use. More...
void | GDALDeregisterDriver (GDALDriverH)
| Deregister the passed driver. More...
void | GDALDestroyDriverManager (void)
| Destroy the driver manager. More...
CPLErr | GDALDeleteDataset (GDALDriverH, const char *)
| Delete named dataset. More...
CPLErr | GDALRenameDataset (GDALDriverH, const char *pszNewName, const char *pszOldName)
| Rename a dataset. More...
CPLErr | GDALCopyDatasetFiles (GDALDriverH, const char *pszNewName, const char *pszOldName)
| Copy the files of a dataset. More...
int | GDALValidateCreationOptions (GDALDriverH, char **papszCreationOptions)
| Validate the list of creation options that are handled by a driver. More...
const char * | GDALGetDriverShortName (GDALDriverH)
| Return the short name of a driver. More...
const char * | GDALGetDriverLongName (GDALDriverH)
| Return the long name of a driver. More...
const char * | GDALGetDriverHelpTopic (GDALDriverH)
| Return the URL to the help that describes the driver. More...
const char * | GDALGetDriverCreationOptionList (GDALDriverH)
| Return the list of creation options of the driver. More...
void | GDALInitGCPs (int, GDAL_GCP *)
| Initialize an array of GCPs. More...
void | GDALDeinitGCPs (int, GDAL_GCP *)
| De-initialize an array of GCPs (initialized with GDALInitGCPs()) More...
GDAL_GCP * | GDALDuplicateGCPs (int, const GDAL_GCP *)
| Duplicate an array of GCPs. More...
int | GDALGCPsToGeoTransform (int nGCPCount, const GDAL_GCP *pasGCPs, double *padfGeoTransform, int bApproxOK) CPL_WARN_UNUSED_RESULT
| Generate Geotransform from GCPs. More...
int | GDALInvGeoTransform (double *padfGeoTransformIn, double *padfInvGeoTransformOut) CPL_WARN_UNUSED_RESULT
| Invert Geotransform. More...
void | GDALApplyGeoTransform (double *, double, double, double *, double *)
| Apply GeoTransform to x/y coordinate. More...
void | GDALComposeGeoTransforms (const double *padfGeoTransform1, const double *padfGeoTransform2, double *padfGeoTransformOut)
| Compose two geotransforms. More...
char ** | GDALGetMetadataDomainList (GDALMajorObjectH hObject)
| Fetch list of metadata domains. More...
char ** | GDALGetMetadata (GDALMajorObjectH, const char *)
| Fetch metadata. More...
CPLErr | GDALSetMetadata (GDALMajorObjectH, char **, const char *)
| Set metadata. More...
const char * | GDALGetMetadataItem (GDALMajorObjectH, const char *, const char *)
| Fetch single metadata item. More...
CPLErr | GDALSetMetadataItem (GDALMajorObjectH, const char *, const char *, const char *)
| Set single metadata item. More...
const char * | GDALGetDescription (GDALMajorObjectH)
| Fetch object description. More...
void | GDALSetDescription (GDALMajorObjectH, const char *)
| Set object description. More...
GDALDriverH | GDALGetDatasetDriver (GDALDatasetH)
| Fetch the driver to which this dataset relates. More...
char ** | GDALGetFileList (GDALDatasetH)
| Fetch files forming dataset. More...
void | GDALClose (GDALDatasetH)
| Close GDAL dataset. More...
int | GDALGetRasterXSize (GDALDatasetH)
| Fetch raster width in pixels. More...
int | GDALGetRasterYSize (GDALDatasetH)
| Fetch raster height in pixels. More...
int | GDALGetRasterCount (GDALDatasetH)
| Fetch the number of raster bands on this dataset. More...
GDALRasterBandH | GDALGetRasterBand (GDALDatasetH, int)
| Fetch a band object for a dataset. More...
CPLErr | GDALAddBand (GDALDatasetH hDS, GDALDataType eType, char **papszOptions)
| Add a band to a dataset. More...
GDALAsyncReaderH | GDALBeginAsyncReader (GDALDatasetH hDS, int nXOff, int nYOff, int nXSize, int nYSize, void *pBuf, int nBufXSize, int nBufYSize, GDALDataType eBufType, int nBandCount, int *panBandMap, int nPixelSpace, int nLineSpace, int nBandSpace, char **papszOptions) CPL_WARN_UNUSED_RESULT
| Sets up an asynchronous data request. More...
void | GDALEndAsyncReader (GDALDatasetH hDS, GDALAsyncReaderH hAsynchReaderH)
| End asynchronous request. More...
CPLErr | GDALDatasetRasterIO (GDALDatasetH hDS, GDALRWFlag eRWFlag, int nDSXOff, int nDSYOff, int nDSXSize, int nDSYSize, void *pBuffer, int nBXSize, int nBYSize, GDALDataType eBDataType, int nBandCount, int *panBandCount, int nPixelSpace, int nLineSpace, int nBandSpace) CPL_WARN_UNUSED_RESULT
| Read/write a region of image data from multiple bands. More...
CPLErr | GDALDatasetRasterIOEx (GDALDatasetH hDS, GDALRWFlag eRWFlag, int nDSXOff, int nDSYOff, int nDSXSize, int nDSYSize, void *pBuffer, int nBXSize, int nBYSize, GDALDataType eBDataType, int nBandCount, int *panBandCount, GSpacing nPixelSpace, GSpacing nLineSpace, GSpacing nBandSpace, GDALRasterIOExtraArg *psExtraArg) CPL_WARN_UNUSED_RESULT
| Read/write a region of image data from multiple bands. More...
CPLErr | GDALDatasetAdviseRead (GDALDatasetH hDS, int nDSXOff, int nDSYOff, int nDSXSize, int nDSYSize, int nBXSize, int nBYSize, GDALDataType eBDataType, int nBandCount, int *panBandCount, char **papszOptions)
| Advise driver of upcoming read requests. More...
const char * | GDALGetProjectionRef (GDALDatasetH)
| Fetch the projection definition string for this dataset. More...
CPLErr | GDALSetProjection (GDALDatasetH, const char *)
| Set the projection reference string for this dataset. More...
CPLErr | GDALGetGeoTransform (GDALDatasetH, double *)
| Fetch the affine transformation coefficients. More...
CPLErr | GDALSetGeoTransform (GDALDatasetH, double *)
| Set the affine transformation coefficients. More...
int | GDALGetGCPCount (GDALDatasetH)
| Get number of GCPs. More...
const char * | GDALGetGCPProjection (GDALDatasetH)
| Get output projection for GCPs. More...
const GDAL_GCP * | GDALGetGCPs (GDALDatasetH)
| Fetch GCPs. More...
CPLErr | GDALSetGCPs (GDALDatasetH, int, const GDAL_GCP *, const char *)
| Assign GCPs. More...
void * | GDALGetInternalHandle (GDALDatasetH, const char *)
| Fetch a format specific internally meaningful handle. More...
int | GDALReferenceDataset (GDALDatasetH)
| Add one to dataset reference count. More...
int | GDALDereferenceDataset (GDALDatasetH)
| Subtract one from dataset reference count. More...
int | GDALReleaseDataset (GDALDatasetH)
| Drop a reference to this object, and destroy if no longer referenced. More...
CPLErr | GDALBuildOverviews (GDALDatasetH, const char *, int, int *, int, int *, GDALProgressFunc, void *) CPL_WARN_UNUSED_RESULT
| Build raster overview(s) More...
void | GDALGetOpenDatasets (GDALDatasetH **hDS, int *pnCount)
| Fetch all open GDAL dataset handles. More...
int | GDALGetAccess (GDALDatasetH hDS)
| Return access flag. More...
void | GDALFlushCache (GDALDatasetH hDS)
| Flush all write cached data to disk. More...
CPLErr | GDALCreateDatasetMaskBand (GDALDatasetH hDS, int nFlags)
| Adds a mask band to the dataset. More...
CPLErr | GDALDatasetCopyWholeRaster (GDALDatasetH hSrcDS, GDALDatasetH hDstDS, char **papszOptions, GDALProgressFunc pfnProgress, void *pProgressData) CPL_WARN_UNUSED_RESULT
| Copy all dataset raster data. More...
CPLErr | GDALRasterBandCopyWholeRaster (GDALRasterBandH hSrcBand, GDALRasterBandH hDstBand, const char *const *constpapszOptions, GDALProgressFunc pfnProgress, void *pProgressData) CPL_WARN_UNUSED_RESULT
| Copy all raster band raster data. More...
CPLErr | GDALRegenerateOverviews (GDALRasterBandH hSrcBand, int nOverviewCount, GDALRasterBandH *pahOverviewBands, const char *pszResampling, GDALProgressFunc pfnProgress, void *pProgressData)
| Generate downsampled overviews. More...
int | GDALDatasetGetLayerCount (GDALDatasetH)
| Get the number of layers in this dataset. More...
OGRLayerH | GDALDatasetGetLayer (GDALDatasetH, int)
| Fetch a layer by index. More...
OGRLayerH | GDALDatasetGetLayerByName (GDALDatasetH, const char *)
| Fetch a layer by name. More...
OGRErr | GDALDatasetDeleteLayer (GDALDatasetH, int)
| Delete the indicated layer from the datasource. More...
OGRLayerH | GDALDatasetCreateLayer (GDALDatasetH, const char *, OGRSpatialReferenceH, OGRwkbGeometryType, char **)
| This function attempts to create a new layer on the dataset with the indicated name, coordinate system, geometry type. More...
OGRLayerH | GDALDatasetCopyLayer (GDALDatasetH, OGRLayerH, const char *, char **)
| Duplicate an existing layer. More...
void | GDALDatasetResetReading (GDALDatasetH)
| Reset feature reading to start on the first feature. More...
OGRFeatureH | GDALDatasetGetNextFeature (GDALDatasetH hDS, OGRLayerH *phBelongingLayer, double *pdfProgressPct, GDALProgressFunc pfnProgress, void *pProgressData)
| Fetch the next available feature from this dataset. More...
int | GDALDatasetTestCapability (GDALDatasetH, const char *)
| Test if capability is available. More...
OGRLayerH | GDALDatasetExecuteSQL (GDALDatasetH, const char *, OGRGeometryH, const char *)
| Execute an SQL statement against the data store. More...
void | GDALDatasetReleaseResultSet (GDALDatasetH, OGRLayerH)
| Release results of ExecuteSQL(). More...
OGRStyleTableH | GDALDatasetGetStyleTable (GDALDatasetH)
| Returns dataset style table. More...
void | GDALDatasetSetStyleTableDirectly (GDALDatasetH, OGRStyleTableH)
| Set dataset style table. More...
void | GDALDatasetSetStyleTable (GDALDatasetH, OGRStyleTableH)
| Set dataset style table. More...
OGRErr | GDALDatasetStartTransaction (GDALDatasetH hDS, int bForce)
| For datasources which support transactions, StartTransaction creates a transaction. More...
OGRErr | GDALDatasetCommitTransaction (GDALDatasetH hDS)
| For datasources which support transactions, CommitTransaction commits a transaction. More...
OGRErr | GDALDatasetRollbackTransaction (GDALDatasetH hDS)
| For datasources which support transactions, RollbackTransaction will roll back a datasource to its state before the start of the current transaction. More...
GDALDataType | GDALGetRasterDataType (GDALRasterBandH)
| Fetch the pixel data type for this band. More...
void | GDALGetBlockSize (GDALRasterBandH, int *pnXSize, int *pnYSize)
| Fetch the "natural" block size of this band. More...
CPLErr | GDALGetActualBlockSize (GDALRasterBandH, int nXBlockOff, int nYBlockOff, int *pnXValid, int *pnYValid)
| Retrieve the actual block size for a given block offset. More...
CPLErr | GDALRasterAdviseRead (GDALRasterBandH hRB, int nDSXOff, int nDSYOff, int nDSXSize, int nDSYSize, int nBXSize, int nBYSize, GDALDataType eBDataType, char **papszOptions)
| Advise driver of upcoming read requests. More...
CPLErr | GDALRasterIO (GDALRasterBandH hRBand, GDALRWFlag eRWFlag, int nDSXOff, int nDSYOff, int nDSXSize, int nDSYSize, void *pBuffer, int nBXSize, int nBYSize, GDALDataType eBDataType, int nPixelSpace, int nLineSpace) CPL_WARN_UNUSED_RESULT
| Read/write a region of image data for this band. More...
CPLErr | GDALRasterIOEx (GDALRasterBandH hRBand, GDALRWFlag eRWFlag, int nDSXOff, int nDSYOff, int nDSXSize, int nDSYSize, void *pBuffer, int nBXSize, int nBYSize, GDALDataType eBDataType, GSpacing nPixelSpace, GSpacing nLineSpace, GDALRasterIOExtraArg *psExtraArg) CPL_WARN_UNUSED_RESULT
| Read/write a region of image data for this band. More...
CPLErr | GDALReadBlock (GDALRasterBandH, int, int, void *) CPL_WARN_UNUSED_RESULT
| Read a block of image data efficiently. More...
CPLErr | GDALWriteBlock (GDALRasterBandH, int, int, void *) CPL_WARN_UNUSED_RESULT
| Write a block of image data efficiently. More...
int | GDALGetRasterBandXSize (GDALRasterBandH)
| Fetch XSize of raster. More...
int | GDALGetRasterBandYSize (GDALRasterBandH)
| Fetch YSize of raster. More...
GDALAccess | GDALGetRasterAccess (GDALRasterBandH)
| Find out if we have update permission for this band. More...
int | GDALGetBandNumber (GDALRasterBandH)
| Fetch the band number. More...
GDALDatasetH | GDALGetBandDataset (GDALRasterBandH)
| Fetch the owning dataset handle. More...
GDALColorInterp | GDALGetRasterColorInterpretation (GDALRasterBandH)
| How should this band be interpreted as color? More...
CPLErr | GDALSetRasterColorInterpretation (GDALRasterBandH, GDALColorInterp)
| Set color interpretation of a band. More...
GDALColorTableH | GDALGetRasterColorTable (GDALRasterBandH)
| Fetch the color table associated with band. More...
CPLErr | GDALSetRasterColorTable (GDALRasterBandH, GDALColorTableH)
| Set the raster color table. More...
int | GDALHasArbitraryOverviews (GDALRasterBandH)
| Check for arbitrary overviews. More...
int | GDALGetOverviewCount (GDALRasterBandH)
| Return the number of overview layers available. More...
GDALRasterBandH | GDALGetOverview (GDALRasterBandH, int)
| Fetch overview raster band object. More...
double | GDALGetRasterNoDataValue (GDALRasterBandH, int *)
| Fetch the no data value for this band. More...
CPLErr | GDALSetRasterNoDataValue (GDALRasterBandH, double)
| Set the no data value for this band. More...
CPLErr | GDALDeleteRasterNoDataValue (GDALRasterBandH)
| Remove the no data value for this band. More...
char ** | GDALGetRasterCategoryNames (GDALRasterBandH)
| Fetch the list of category names for this raster. More...
CPLErr | GDALSetRasterCategoryNames (GDALRasterBandH, char **)
| Set the category names for this band. More...
double | GDALGetRasterMinimum (GDALRasterBandH, int *pbSuccess)
| Fetch the minimum value for this band. More...
double | GDALGetRasterMaximum (GDALRasterBandH, int *pbSuccess)
| Fetch the maximum value for this band. More...
CPLErr | GDALGetRasterStatistics (GDALRasterBandH, int bApproxOK, int bForce, double *pdfMin, double *pdfMax, double *pdfMean, double *pdfStdDev)
| Fetch image statistics. More...
CPLErr | GDALComputeRasterStatistics (GDALRasterBandH, int bApproxOK, double *pdfMin, double *pdfMax, double *pdfMean, double *pdfStdDev, GDALProgressFunc pfnProgress, void *pProgressData)
| Compute image statistics. More...
CPLErr | GDALSetRasterStatistics (GDALRasterBandH hBand, double dfMin, double dfMax, double dfMean, double dfStdDev)
| Set statistics on band. More...
const char * | GDALGetRasterUnitType (GDALRasterBandH)
| Return raster unit type. More...
CPLErr | GDALSetRasterUnitType (GDALRasterBandH hBand, const char *pszNewValue)
| Set unit type. More...
double | GDALGetRasterOffset (GDALRasterBandH, int *pbSuccess)
| Fetch the raster value offset. More...
CPLErr | GDALSetRasterOffset (GDALRasterBandH hBand, double dfNewOffset)
| Set scaling offset. More...
double | GDALGetRasterScale (GDALRasterBandH, int *pbSuccess)
| Fetch the raster value scale. More...
CPLErr | GDALSetRasterScale (GDALRasterBandH hBand, double dfNewOffset)
| Set scaling ratio. More...
void | GDALComputeRasterMinMax (GDALRasterBandH hBand, int bApproxOK, double adfMinMax[2])
| Compute the min/max values for a band. More...
CPLErr | GDALFlushRasterCache (GDALRasterBandH hBand)
| Flush raster data cache. More...
CPLErr | GDALGetRasterHistogram (GDALRasterBandH hBand, double dfMin, double dfMax, int nBuckets, int *panHistogram, int bIncludeOutOfRange, int bApproxOK, GDALProgressFunc pfnProgress, void *pProgressData) CPL_WARN_DEPRECATED("Use GDALGetRasterHistogramEx() instead")
| Compute raster histogram. More...
CPLErr | GDALGetRasterHistogramEx (GDALRasterBandH hBand, double dfMin, double dfMax, int nBuckets, GUIntBig *panHistogram, int bIncludeOutOfRange, int bApproxOK, GDALProgressFunc pfnProgress, void *pProgressData)
| Compute raster histogram. More...
CPLErr | GDALGetDefaultHistogram (GDALRasterBandH hBand, double *pdfMin, double *pdfMax, int *pnBuckets, int **ppanHistogram, int bForce, GDALProgressFunc pfnProgress, void *pProgressData) CPL_WARN_DEPRECATED("Use GDALGetDefaultHistogramEx() instead")
| Fetch default raster histogram. More...
CPLErr | GDALGetDefaultHistogramEx (GDALRasterBandH hBand, double *pdfMin, double *pdfMax, int *pnBuckets, GUIntBig **ppanHistogram, int bForce, GDALProgressFunc pfnProgress, void *pProgressData)
| Fetch default raster histogram. More...
CPLErr | GDALSetDefaultHistogram (GDALRasterBandH hBand, double dfMin, double dfMax, int nBuckets, int *panHistogram) CPL_WARN_DEPRECATED("Use GDALSetDefaultHistogramEx() instead")
| Set default histogram. More...
CPLErr | GDALSetDefaultHistogramEx (GDALRasterBandH hBand, double dfMin, double dfMax, int nBuckets, GUIntBig *panHistogram)
| Set default histogram. More...
int | GDALGetRandomRasterSample (GDALRasterBandH, int, float *)
| Undocumented. More...
GDALRasterBandH | GDALGetRasterSampleOverview (GDALRasterBandH, int)
| Fetch best sampling overview. More...
GDALRasterBandH | GDALGetRasterSampleOverviewEx (GDALRasterBandH, GUIntBig)
| Fetch best sampling overview. More...
CPLErr | GDALFillRaster (GDALRasterBandH hBand, double dfRealValue, double dfImaginaryValue)
| Fill this band with a constant value. More...
CPLErr | GDALComputeBandStats (GDALRasterBandH hBand, int nSampleStep, double *pdfMean, double *pdfStdDev, GDALProgressFunc pfnProgress, void *pProgressData)
| Undocumented. More...
CPLErr | GDALOverviewMagnitudeCorrection (GDALRasterBandH hBaseBand, int nOverviewCount, GDALRasterBandH *pahOverviews, GDALProgressFunc pfnProgress, void *pProgressData)
| Undocumented. More...
GDALRasterAttributeTableH | GDALGetDefaultRAT (GDALRasterBandH hBand)
| Fetch default Raster Attribute Table. More...
CPLErr | GDALSetDefaultRAT (GDALRasterBandH, GDALRasterAttributeTableH)
| Set default Raster Attribute Table. More...
CPLErr | GDALAddDerivedBandPixelFunc (const char *pszName, GDALDerivedPixelFunc pfnPixelFunc)
| This adds a pixel function to the global list of available pixel functions for derived bands. More...
GDALRasterBandH | GDALGetMaskBand (GDALRasterBandH hBand)
| Return the mask band associated with the band. More...
int | GDALGetMaskFlags (GDALRasterBandH hBand)
| Return the status flags of the mask band associated with the band. More...
CPLErr | GDALCreateMaskBand (GDALRasterBandH hBand, int nFlags)
| Adds a mask band to the current band. More...
int | GDALGetDataCoverageStatus (GDALRasterBandH hBand, int nXOff, int nYOff, int nXSize, int nYSize, int nMaskFlagStop, double *pdfDataPct)
| Get the coverage status of a sub-window of the raster. More...
GDALAsyncStatusType | GDALARGetNextUpdatedRegion (GDALAsyncReaderH hARIO, double dfTimeout, int *pnXBufOff, int *pnYBufOff, int *pnXBufSize, int *pnYBufSize)
| Get async IO update. More...
int | GDALARLockBuffer (GDALAsyncReaderH hARIO, double dfTimeout)
| Lock image buffer. More...
void | GDALARUnlockBuffer (GDALAsyncReaderH hARIO)
| Unlock image buffer. More...
int | GDALGeneralCmdLineProcessor (int nArgc, char ***ppapszArgv, int nOptions)
| General utility option processing. More...
void | GDALSwapWords (void *pData, int nWordSize, int nWordCount, int nWordSkip)
| Byte swap words in-place. More...
void | GDALSwapWordsEx (void *pData, int nWordSize, size_t nWordCount, int nWordSkip)
| Byte swap words in-place. More...
void | GDALCopyWords (const void *CPL_RESTRICT pSrcData, GDALDataType eSrcType, int nSrcPixelOffset, void *CPL_RESTRICT pDstData, GDALDataType eDstType, int nDstPixelOffset, int nWordCount)
| Copy pixel words from buffer to buffer. More...
void | GDALCopyBits (const GByte *pabySrcData, int nSrcOffset, int nSrcStep, GByte *pabyDstData, int nDstOffset, int nDstStep, int nBitCount, int nStepCount)
| Bitwise word copying. More...
int | GDALLoadWorldFile (const char *, double *)
| Read ESRI world file. More...
int | GDALReadWorldFile (const char *, const char *, double *)
| Read ESRI world file. More...
int | GDALWriteWorldFile (const char *, const char *, double *)
| Write ESRI world file. More...
int | GDALLoadTabFile (const char *, double *, char **, int *, GDAL_GCP **)
| Helper function for translator implementer wanting support for MapInfo .tab files. More...
int | GDALReadTabFile (const char *, double *, char **, int *, GDAL_GCP **)
| Helper function for translator implementer wanting support for MapInfo .tab files. More...
int | GDALLoadOziMapFile (const char *, double *, char **, int *, GDAL_GCP **)
| Helper function for translator implementer wanting support for OZI .map. More...
int | GDALReadOziMapFile (const char *, double *, char **, int *, GDAL_GCP **)
| Helper function for translator implementer wanting support for OZI .map. More...
const char * | GDALDecToDMS (double, const char *, int)
| Translate a decimal degrees value to a DMS string with hemisphere.
double | GDALPackedDMSToDec (double)
| Convert a packed DMS value (DDDMMMSSS.SS) into decimal degrees. More...
double | GDALDecToPackedDMS (double)
| Convert decimal degrees into packed DMS value (DDDMMMSSS.SS). More...
const char * | GDALVersionInfo (const char *)
| Get runtime version information. More...
int | GDALCheckVersion (int nVersionMajor, int nVersionMinor, const char *pszCallingComponentName)
| Return TRUE if GDAL library version at runtime matches nVersionMajor.nVersionMinor. More...
int | GDALExtractRPCInfo (char **, GDALRPCInfo *)
| Extract RPC info from metadata, and apply to an RPCInfo structure. More...
GDALColorTableH | GDALCreateColorTable (GDALPaletteInterp) CPL_WARN_UNUSED_RESULT
| Construct a new color table. More...
void | GDALDestroyColorTable (GDALColorTableH)
| Destroys a color table. More...
GDALColorTableH | GDALCloneColorTable (GDALColorTableH)
| Make a copy of a color table. More...
GDALPaletteInterp | GDALGetPaletteInterpretation (GDALColorTableH)
| Fetch palette interpretation. More...
int | GDALGetColorEntryCount (GDALColorTableH)
| Get number of color entries in table. More...
const GDALColorEntry * | GDALGetColorEntry (GDALColorTableH, int)
| Fetch a color entry from table. More...
int | GDALGetColorEntryAsRGB (GDALColorTableH, int, GDALColorEntry *)
| Fetch a table entry in RGB format. More...
void | GDALSetColorEntry (GDALColorTableH, int, const GDALColorEntry *)
| Set entry in color table. More...
void | GDALCreateColorRamp (GDALColorTableH hTable, int nStartIndex, const GDALColorEntry *psStartColor, int nEndIndex, const GDALColorEntry *psEndColor)
| Create color ramp. More...
GDALRasterAttributeTableH | GDALCreateRasterAttributeTable (void) CPL_WARN_UNUSED_RESULT
| Construct empty table. More...
void | GDALDestroyRasterAttributeTable (GDALRasterAttributeTableH)
| Destroys a RAT. More...
int | GDALRATGetColumnCount (GDALRasterAttributeTableH)
| Fetch table column count. More...
const char * | GDALRATGetNameOfCol (GDALRasterAttributeTableH, int)
| Fetch name of indicated column. More...
GDALRATFieldUsage | GDALRATGetUsageOfCol (GDALRasterAttributeTableH, int)
| Fetch column usage value. More...
GDALRATFieldType | GDALRATGetTypeOfCol (GDALRasterAttributeTableH, int)
| Fetch column type. More...
int | GDALRATGetColOfUsage (GDALRasterAttributeTableH, GDALRATFieldUsage)
| Fetch column index for given usage. More...
int | GDALRATGetRowCount (GDALRasterAttributeTableH)
| Fetch row count. More...
const char * | GDALRATGetValueAsString (GDALRasterAttributeTableH, int, int)
| Fetch field value as a string. More...
int | GDALRATGetValueAsInt (GDALRasterAttributeTableH, int, int)
| Fetch field value as a integer. More...
double | GDALRATGetValueAsDouble (GDALRasterAttributeTableH, int, int)
| Fetch field value as a double. More...
void | GDALRATSetValueAsString (GDALRasterAttributeTableH, int, int, const char *)
| Set field value from string. More...
void | GDALRATSetValueAsInt (GDALRasterAttributeTableH, int, int, int)
| Set field value from integer. More...
void | GDALRATSetValueAsDouble (GDALRasterAttributeTableH, int, int, double)
| Set field value from double. More...
int | GDALRATChangesAreWrittenToFile (GDALRasterAttributeTableH hRAT)
| Determine whether changes made to this RAT are reflected directly in the dataset. More...
CPLErr | GDALRATValuesIOAsDouble (GDALRasterAttributeTableH hRAT, GDALRWFlag eRWFlag, int iField, int iStartRow, int iLength, double *pdfData)
| Read or Write a block of doubles to/from the Attribute Table. More...
CPLErr | GDALRATValuesIOAsInteger (GDALRasterAttributeTableH hRAT, GDALRWFlag eRWFlag, int iField, int iStartRow, int iLength, int *pnData)
| Read or Write a block of ints to/from the Attribute Table. More...
CPLErr | GDALRATValuesIOAsString (GDALRasterAttributeTableH hRAT, GDALRWFlag eRWFlag, int iField, int iStartRow, int iLength, char **papszStrList)
| Read or Write a block of strings to/from the Attribute Table. More...
void | GDALRATSetRowCount (GDALRasterAttributeTableH, int)
| Set row count. More...
CPLErr | GDALRATCreateColumn (GDALRasterAttributeTableH, const char *, GDALRATFieldType, GDALRATFieldUsage)
| Create new column. More...
CPLErr | GDALRATSetLinearBinning (GDALRasterAttributeTableH, double, double)
| Set linear binning information. More...
int | GDALRATGetLinearBinning (GDALRasterAttributeTableH, double *, double *)
| Get linear binning information. More...
CPLErr | GDALRATInitializeFromColorTable (GDALRasterAttributeTableH, GDALColorTableH)
| Initialize from color table. More...
GDALColorTableH | GDALRATTranslateToColorTable (GDALRasterAttributeTableH, int nEntryCount)
| Translate to a color table. More...
void | GDALRATDumpReadable (GDALRasterAttributeTableH, FILE *)
| Dump RAT in readable form. More...
GDALRasterAttributeTableH | GDALRATClone (GDALRasterAttributeTableH)
| Copy Raster Attribute Table. More...
void * | GDALRATSerializeJSON (GDALRasterAttributeTableH) CPL_WARN_UNUSED_RESULT
| Serialize Raster Attribute Table in Json format. More...
int | GDALRATGetRowOfValue (GDALRasterAttributeTableH, double)
| Get row for pixel value. More...
void | GDALSetCacheMax (int nBytes)
| Set maximum cache memory. More...
int | GDALGetCacheMax (void)
| Get maximum cache memory. More...
int | GDALGetCacheUsed (void)
| Get cache memory used. More...
void | GDALSetCacheMax64 (GIntBig nBytes)
| Set maximum cache memory. More...
GIntBig | GDALGetCacheMax64 (void)
| Get maximum cache memory. More...
GIntBig | GDALGetCacheUsed64 (void)
| Get cache memory used. More...
int | GDALFlushCacheBlock (void)
| Try to flush one cached raster block. More...
CPLVirtualMem * | GDALDatasetGetVirtualMem (GDALDatasetH hDS, GDALRWFlag eRWFlag, int nXOff, int nYOff, int nXSize, int nYSize, int nBufXSize, int nBufYSize, GDALDataType eBufType, int nBandCount, int *panBandMap, int nPixelSpace, GIntBig nLineSpace, GIntBig nBandSpace, size_t nCacheSize, size_t nPageSizeHint, int bSingleThreadUsage, char **papszOptions) CPL_WARN_UNUSED_RESULT
| Create a CPLVirtualMem object from a GDAL dataset object. More...
CPLVirtualMem * | GDALRasterBandGetVirtualMem (GDALRasterBandH hBand, GDALRWFlag eRWFlag, int nXOff, int nYOff, int nXSize, int nYSize, int nBufXSize, int nBufYSize, GDALDataType eBufType, int nPixelSpace, GIntBig nLineSpace, size_t nCacheSize, size_t nPageSizeHint, int bSingleThreadUsage, char **papszOptions) CPL_WARN_UNUSED_RESULT
| Create a CPLVirtualMem object from a GDAL raster band object. More...
CPLVirtualMem * | GDALGetVirtualMemAuto (GDALRasterBandH hBand, GDALRWFlag eRWFlag, int *pnPixelSpace, GIntBig *pnLineSpace, char **papszOptions) CPL_WARN_UNUSED_RESULT
| Create a CPLVirtualMem object from a GDAL raster band object. More...
CPLVirtualMem * | GDALDatasetGetTiledVirtualMem (GDALDatasetH hDS, GDALRWFlag eRWFlag, int nXOff, int nYOff, int nXSize, int nYSize, int nTileXSize, int nTileYSize, GDALDataType eBufType, int nBandCount, int *panBandMap, GDALTileOrganization eTileOrganization, size_t nCacheSize, int bSingleThreadUsage, char **papszOptions) CPL_WARN_UNUSED_RESULT
| Create a CPLVirtualMem object from a GDAL dataset object, with tiling organization. More...
CPLVirtualMem * | GDALRasterBandGetTiledVirtualMem (GDALRasterBandH hBand, GDALRWFlag eRWFlag, int nXOff, int nYOff, int nXSize, int nYSize, int nTileXSize, int nTileYSize, GDALDataType eBufType, size_t nCacheSize, int bSingleThreadUsage, char **papszOptions) CPL_WARN_UNUSED_RESULT
| Create a CPLVirtualMem object from a GDAL rasterband object, with tiling organization. More...
GDALDatasetH | GDALCreatePansharpenedVRT (const char *pszXML, GDALRasterBandH hPanchroBand, int nInputSpectralBands, GDALRasterBandH *pahInputSpectralBands) CPL_WARN_UNUSED_RESULT
| Create a virtual pansharpened dataset. More...
CPLXMLNode * | GDALGetJPEG2000Structure (const char *pszFilename, char **papszOptions) CPL_WARN_UNUSED_RESULT
| Dump the structure of a JPEG2000 file as a XML tree. More...

## Detailed Description

Public (C callable) GDAL entry points.

## Macro Definition Documentation

#define GDAL_CHECK_VERSION | ( |  | pszCallingComponentName | ) | GDALCheckVersion(GDAL_VERSION_MAJOR, GDAL_VERSION_MINOR, pszCallingComponentName)

Helper macro for GDALCheckVersion()

See also
  GDALCheckVersion()

#define GDAL_DATA_COVERAGE_STATUS_DATA 0x02

Flag returned by GDALGetDataCoverageStatus() when there is (potentially) data in the queried window.

Can be combined with the binary or operator with GDAL_DATA_COVERAGE_STATUS_UNIMPLEMENTED or GDAL_DATA_COVERAGE_STATUS_EMPTY

#define GDAL_DATA_COVERAGE_STATUS_EMPTY 0x04

Flag returned by GDALGetDataCoverageStatus() when there is nodata in the queried window.

This is typically identified by the concept of missing block in formats that supports it. Can be combined with the binary or operator with GDAL_DATA_COVERAGE_STATUS_DATA

#define GDAL_DATA_COVERAGE_STATUS_UNIMPLEMENTED 0x01

Flag returned by GDALGetDataCoverageStatus() when the driver does not implement GetDataCoverageStatus().

This flag should be returned together with GDAL_DATA_COVERAGE_STATUS_DATA

#define GDAL_DCAP_CREATE "DCAP_CREATE"

Capability set by a driver that implements the Create() API.

#define GDAL_DCAP_CREATECOPY "DCAP_CREATECOPY"

Capability set by a driver that implements the CreateCopy() API.

#define GDAL_DCAP_DEFAULT_FIELDS "DCAP_DEFAULT_FIELDS"

Capability set by a driver that can create fields with DEFAULT values.

Since
  GDAL 2.0

#define GDAL_DCAP_GNM "DCAP_GNM"

Capability set by a driver having vector capability.

Since
  GDAL 2.1

#define GDAL_DCAP_NOTNULL_FIELDS "DCAP_NOTNULL_FIELDS"

Capability set by a driver that can create fields with NOT NULL constraint.

Since
  GDAL 2.0

#define GDAL_DCAP_NOTNULL_GEOMFIELDS "DCAP_NOTNULL_GEOMFIELDS"

Capability set by a driver that can create geometry fields with NOT NULL constraint.

Since
  GDAL 2.0

#define GDAL_DCAP_OPEN "DCAP_OPEN"

Capability set by a driver that implements the Open() API.

#define GDAL_DCAP_RASTER "DCAP_RASTER"

Capability set by a driver having raster capability.

Since
  GDAL 2.0

#define GDAL_DCAP_VECTOR "DCAP_VECTOR"

Capability set by a driver having vector capability.

Since
  GDAL 2.0

#define GDAL_DCAP_VIRTUALIO "DCAP_VIRTUALIO"

Capability set by a driver that can read/create datasets through the VSI*L API.

#define GDAL_DMD_CONNECTION_PREFIX "DMD_CONNECTION_PREFIX"

Connection prefix to provide as the file name of the open function.

Typically set for non-file based drivers. Generally used with open options.

Since
  GDAL 2.0

#define GDAL_DMD_CREATIONDATATYPES "DMD_CREATIONDATATYPES"

List of (space separated) raster data types support by the Create()/CreateCopy() API.

#define GDAL_DMD_CREATIONFIELDDATATYPES "DMD_CREATIONFIELDDATATYPES"

List of (space separated) vector field types support by the CreateField() API.

Since
  GDAL 2.0

#define GDAL_DMD_CREATIONOPTIONLIST "DMD_CREATIONOPTIONLIST"

XML snippet with creation options.

#define GDAL_DMD_EXTENSION "DMD_EXTENSION"

Extension handled by the driver.

#define GDAL_DMD_EXTENSIONS "DMD_EXTENSIONS"

List of (space separated) extensions handled by the driver.

Since
  GDAL 2.0

#define GDAL_DMD_MIMETYPE "DMD_MIMETYPE"

MIME type handled by the driver.

#define GDAL_DMD_OPENOPTIONLIST "DMD_OPENOPTIONLIST"

XML snippet with open options.

Since
  GDAL 2.0

#define GDAL_DMD_SUBDATASETS "DMD_SUBDATASETS"

Capability set by a driver that exposes Subdatasets.

#define GDAL_OF_ALL 0x00

Allow raster and vector drivers to be used.

Used by GDALOpenEx().

Since
  GDAL 2.0

#define GDAL_OF_ARRAY_BLOCK_ACCESS 0x100

Use a array-based storage strategy for cached blocks.

GDAL_OF_DEFAULT_BLOCK_ACCESS, GDAL_OF_ARRAY_BLOCK_ACCESS and GDAL_OF_HASHSET_BLOCK_ACCESS are mutually exclusive.

Used by GDALOpenEx().

Since
  GDAL 2.1

#define GDAL_OF_DEFAULT_BLOCK_ACCESS 0

Let GDAL decide if a array-based or hashset-based storage strategy for cached blocks must be used.

GDAL_OF_DEFAULT_BLOCK_ACCESS, GDAL_OF_ARRAY_BLOCK_ACCESS and GDAL_OF_HASHSET_BLOCK_ACCESS are mutually exclusive.

Used by GDALOpenEx().

Since
  GDAL 2.1

#define GDAL_OF_GNM 0x08

Allow gnm drivers to be used.

Used by GDALOpenEx().

Since
  GDAL 2.1

#define GDAL_OF_HASHSET_BLOCK_ACCESS 0x200

Use a hashset-based storage strategy for cached blocks.

GDAL_OF_DEFAULT_BLOCK_ACCESS, GDAL_OF_ARRAY_BLOCK_ACCESS and GDAL_OF_HASHSET_BLOCK_ACCESS are mutually exclusive.

Used by GDALOpenEx().

Since
  GDAL 2.1

#define GDAL_OF_INTERNAL 0x80

Open as internal dataset.

Such dataset isn't registered in the global list of opened dataset. Cannot be used with GDAL_OF_SHARED.

Used by GDALOpenEx().

Since
  GDAL 2.0

#define GDAL_OF_RASTER 0x02

Allow raster drivers to be used.

Used by GDALOpenEx().

Since
  GDAL 2.0

#define GDAL_OF_READONLY 0x00

Open in read-only mode.

Used by GDALOpenEx().

Since
  GDAL 2.0

#define GDAL_OF_SHARED 0x20

Open in shared mode.

Used by GDALOpenEx().

Since
  GDAL 2.0

#define GDAL_OF_UPDATE 0x01

Open in update mode.

Used by GDALOpenEx().

Since
  GDAL 2.0

#define GDAL_OF_VECTOR 0x04

Allow vector drivers to be used.

Used by GDALOpenEx().

Since
  GDAL 2.0

#define GDAL_OF_VERBOSE_ERROR 0x40

Emit error message in case of failed open.

Used by GDALOpenEx().

Since
  GDAL 2.0

#define INIT_RASTERIO_EXTRA_ARG | ( |  | s | ) |

Value:
do { (s).nVersion = RASTERIO_EXTRA_ARG_CURRENT_VERSION; \
(s).eResampleAlg = GRIORA_NearestNeighbour; \
(s).pfnProgress = NULL; \
(s).pProgressData = NULL; \
(s).bFloatingPointWindowValidity = FALSE; } while(0)
GRIORA_NearestNeighbour
Definition: gdal.h:116

Macro to initialize an instance of GDALRasterIOExtraArg structure.

Since
  GDAL 2.0

#define SRCVAL | ( |  | papoSource,
|  |  | eSrcType,
|  |  | ii
| ) |  |

Value:
(eSrcType == GDT_Byte ? \
((GByte *)papoSource)[ii] : \
(eSrcType == GDT_Float32 ? \
((float *)papoSource)[ii] : \
(eSrcType == GDT_Float64 ? \
((double *)papoSource)[ii] : \
(eSrcType == GDT_Int32 ? \
((GInt32 *)papoSource)[ii] : \
(eSrcType == GDT_UInt16 ? \
((GUInt16 *)papoSource)[ii] : \
(eSrcType == GDT_Int16 ? \
((GInt16 *)papoSource)[ii] : \
(eSrcType == GDT_UInt32 ? \
((GUInt32 *)papoSource)[ii] : \
(eSrcType == GDT_CInt16 ? \
((GInt16 *)papoSource)[ii * 2] : \
(eSrcType == GDT_CInt32 ? \
((GInt32 *)papoSource)[ii * 2] : \
(eSrcType == GDT_CFloat32 ? \
((float *)papoSource)[ii * 2] : \
(eSrcType == GDT_CFloat64 ? \
((double *)papoSource)[ii * 2] : 0)))))))))))
GDT_CInt32
Definition: gdal.h:67
GDT_Byte
Definition: gdal.h:59
GInt32
int GInt32
Int32 type.
Definition: cpl_port.h:197
GDT_UInt16
Definition: gdal.h:60
GDT_Int32
Definition: gdal.h:63
GUInt32
unsigned int GUInt32
Unsigned int32 type.
Definition: cpl_port.h:199
GInt16
short GInt16
Int16 type.
Definition: cpl_port.h:203
GByte
unsigned char GByte
Unsigned byte type.
Definition: cpl_port.h:207
GDT_CFloat64
Definition: gdal.h:69
GDT_UInt32
Definition: gdal.h:62
GDT_Int16
Definition: gdal.h:61
GDT_CFloat32
Definition: gdal.h:68
GUInt16
unsigned short GUInt16
Unsigned int16 type.
Definition: cpl_port.h:205
GDT_Float64
Definition: gdal.h:65
GDT_Float32
Definition: gdal.h:64
GDT_CInt16
Definition: gdal.h:66

SRCVAL - Macro which may be used by pixel functions to obtain a pixel from a source buffer.

## Typedef Documentation

typedef CPLErr(* GDALDerivedPixelFunc) (void **papoSources, int nSources, void *pData, int nBufXSize, int nBufYSize, GDALDataType eSrcType, GDALDataType eBufType, int nPixelSpace, int nLineSpace)

Type of functions to pass to GDALAddDerivedBandPixelFunc.

Since
  GDAL 2.2

typedef GIntBig GSpacing

Type to express pixel, line or band spacing.

Signed 64 bit integer.

## Enumeration Type Documentation

enum GDALAccess

Flag indicating read/write, or read-only access to data.

Enumerator
GA_ReadOnly | Read only (no update) access
GA_Update | Read/write access.

enum GDALColorInterp

Types of color interpretation for raster bands.

Enumerator
GCI_GrayIndex | Greyscale
GCI_PaletteIndex | Paletted (see associated color table)
GCI_RedBand | Red band of RGBA image
GCI_GreenBand | Green band of RGBA image
GCI_BlueBand | Blue band of RGBA image
GCI_AlphaBand | Alpha (0=transparent, 255=opaque)
GCI_HueBand | Hue band of HLS image
GCI_SaturationBand | Saturation band of HLS image
GCI_LightnessBand | Lightness band of HLS image
GCI_CyanBand | Cyan band of CMYK image
GCI_MagentaBand | Magenta band of CMYK image
GCI_YellowBand | Yellow band of CMYK image
GCI_BlackBand | Black band of CMLY image
GCI_YCbCr_YBand | Y Luminance
GCI_YCbCr_CbBand | Cb Chroma
GCI_YCbCr_CrBand | Cr Chroma
GCI_Max | Max current value

enum GDALDataType

Pixel data types

Enumerator
GDT_Unknown | Unknown or unspecified type
GDT_Byte | Eight bit unsigned integer
GDT_UInt16 | Sixteen bit unsigned integer
GDT_Int16 | Sixteen bit signed integer
GDT_UInt32 | Thirty two bit unsigned integer
GDT_Int32 | Thirty two bit signed integer
GDT_Float32 | Thirty two bit floating point
GDT_Float64 | Sixty four bit floating point
GDT_CInt16 | Complex Int16
GDT_CInt32 | Complex Int32
GDT_CFloat32 | Complex Float32
GDT_CFloat64 | Complex Float64

enum GDALPaletteInterp

Types of color interpretations for a GDALColorTable.

Enumerator
GPI_Gray | Grayscale (in GDALColorEntry.c1)
GPI_RGB | Red, Green, Blue and Alpha in (in c1, c2, c3 and c4)
GPI_CMYK | Cyan, Magenta, Yellow and Black (in c1, c2, c3 and c4)
GPI_HLS | Hue, Lightness and Saturation (in c1, c2, and c3)

enum GDALRATFieldType

Field type of raster attribute table.

Enumerator
GFT_Integer | Integer field
GFT_Real | Floating point (double) field
GFT_String | String field

enum GDALRATFieldUsage

Field usage of raster attribute table.

Enumerator
GFU_Generic | General purpose field.
GFU_PixelCount | Histogram pixel count
GFU_Name | Class name
GFU_Min | Class range minimum
GFU_Max | Class range maximum
GFU_MinMax | Class value (min=max)
GFU_Red | Red class color (0-255)
GFU_Green | Green class color (0-255)
GFU_Blue | Blue class color (0-255)
GFU_Alpha | Alpha (0=transparent,255=opaque)
GFU_RedMin | Color Range Red Minimum
GFU_GreenMin | Color Range Green Minimum
GFU_BlueMin | Color Range Blue Minimum
GFU_AlphaMin | Color Range Alpha Minimum
GFU_RedMax | Color Range Red Maximum
GFU_GreenMax | Color Range Green Maximum
GFU_BlueMax | Color Range Blue Maximum
GFU_AlphaMax | Color Range Alpha Maximum
GFU_MaxCount | Maximum GFU value

enum GDALRIOResampleAlg

RasterIO() resampling method.

Since
  GDAL 2.0

Enumerator
GRIORA_NearestNeighbour | Nearest neighbour
GRIORA_Bilinear | Bilinear (2x2 kernel)
GRIORA_Cubic | Cubic Convolution Approximation (4x4 kernel)
GRIORA_CubicSpline | Cubic B-Spline Approximation (4x4 kernel)
GRIORA_Lanczos | Lanczos windowed sinc interpolation (6x6 kernel)
GRIORA_Average | Average
GRIORA_Mode | Mode (selects the value which appears most often of all the sampled points)
GRIORA_Gauss | Gauss blurring

enum GDALRWFlag

Read/Write flag for RasterIO() method

Enumerator
GF_Read | Read data
GF_Write | Write data

enum GDALTileOrganization

! Enumeration to describe the tile organization

Enumerator
GTO_TIP | Tile Interleaved by Pixel: tile (0,0) with internal band interleaved by pixel organization, tile (1, 0), ...
GTO_BIT | Band Interleaved by Tile : tile (0,0) of first band, tile (0,0) of second band, ... tile (1,0) of first band, tile (1,0) of second band, ...
GTO_BSQ | Band SeQuential : all the tiles of first band, all the tiles of following band...

## Function Documentation

CPLErr GDALAddBand | ( | GDALDatasetH | hDataset,
|  | GDALDataType | eType,
|  | char ** | papszOptions
| ) |  |

Add a band to a dataset.

See also
  GDALDataset::AddBand().

CPLErr GDALAddDerivedBandPixelFunc | ( | const char * | pszFuncName,
|  | GDALDerivedPixelFunc | pfnNewFunction
| ) |  |

This adds a pixel function to the global list of available pixel functions for derived bands.

Pixel functions must be registered in this way before a derived band tries to access data.

Derived bands are stored with only the name of the pixel function that it will apply, and if a pixel function matching the name is not found the IRasterIO() call will do nothing.

Parameters

  pszFuncName | Name used to access pixel function
  pfnNewFunction | Pixel function associated with name. An existing pixel function registered with the same name will be replaced with the new one.

Returns
  CE_None, invalid (NULL) parameters are currently ignored.

double GDALAdjustValueToDataType | ( | GDALDataType | eDT,
|  | double | dfValue,
|  | int * | pbClamped,
|  | int * | pbRounded
| ) |  |

Adjust a value to the output data type.

Adjustment consist in clamping to minimum/maxmimum values of the data type and rounding for integral types.

Parameters

  eDT | target data type.
  dfValue | value to adjust.
  pbClamped | pointer to a integer(boolean) to indicate if clamping has been made, or NULL
  pbRounded | pointer to a integer(boolean) to indicate if rounding has been made, or NULL

Returns
  adjusted value

Since
  GDAL 2.1

void GDALAllRegister | ( | void |  | ) |

Register all known configured GDAL drivers.

This function will drive any of the following that are configured into GDAL. See raster list and vector full list

This function should generally be called once at the beginning of the application.

void GDALApplyGeoTransform | ( | double * | padfGeoTransform,
|  | double | dfPixel,
|  | double | dfLine,
|  | double * | pdfGeoX,
|  | double * | pdfGeoY
| ) |  |

Apply GeoTransform to x/y coordinate.

Applies the following computation, converting a (pixel, line) coordinate into a georeferenced (geo_x, geo_y) location.

*pdfGeoX = padfGeoTransform[0] + dfPixel * padfGeoTransform[1]

- dfLine * padfGeoTransform[2]; *pdfGeoY = padfGeoTransform[3] + dfPixel * padfGeoTransform[4]
- dfLine * padfGeoTransform[5];

Parameters

  padfGeoTransform | Six coefficient GeoTransform to apply.
  dfPixel | Input pixel position.
  dfLine | Input line position.
  pdfGeoX | output location where geo_x (easting/longitude) location is placed.
  pdfGeoY | output location where geo_y (northing/latitude) location is placed.

GDALAsyncStatusType GDALARGetNextUpdatedRegion | ( | GDALAsyncReaderH | hARIO,
|  | double | dfTimeout,
|  | int * | pnBufXOff,
|  | int * | pnBufYOff,
|  | int * | pnBufXSize,
|  | int * | pnBufYSize
| ) |  |

Get async IO update.

Provide an opportunity for an asynchronous IO request to update the image buffer and return an indication of the area of the buffer that has been updated.

The dfTimeout parameter can be used to wait for additional data to become available. The timeout does not limit the amount of time this method may spend actually processing available data.

The following return status are possible.

- GARIO_PENDING: No imagery was altered in the buffer, but there is still activity pending, and the application should continue to call GetNextUpdatedRegion() as time permits.
- GARIO_UPDATE: Some of the imagery has been updated, but there is still activity pending.
- GARIO_ERROR: Something has gone wrong. The asynchronous request should be ended.
- GARIO_COMPLETE: An update has occurred and there is no more pending work on this request. The request should be ended and the buffer used.

This is the same as GDALAsyncReader::GetNextUpdatedRegion()

Parameters

  hARIO | handle to the async reader.
  dfTimeout | the number of seconds to wait for additional updates. Use -1 to wait indefinitely, or zero to not wait at all if there is no data available.
  pnBufXOff | location to return the X offset of the area of the request buffer that has been updated.
  pnBufYOff | location to return the Y offset of the area of the request buffer that has been updated.
  pnBufXSize | location to return the X size of the area of the request buffer that has been updated.
  pnBufYSize | location to return the Y size of the area of the request buffer that has been updated.

Returns
  GARIO_ status, details described above.

int GDALARLockBuffer | ( | GDALAsyncReaderH | hARIO,
|  | double | dfTimeout
| ) |  |

Lock image buffer.

Locks the image buffer passed into GDALDataset::BeginAsyncReader(). This is useful to ensure the image buffer is not being modified while it is being used by the application. UnlockBuffer() should be used to release this lock when it is no longer needed.

This is the same as GDALAsyncReader::LockBuffer()

Parameters

  hARIO | handle to async reader.
  dfTimeout | the time in seconds to wait attempting to lock the buffer. -1.0 to wait indefinitely and 0 to not wait at all if it can't be acquired immediately. Default is -1.0 (infinite wait).

Returns
  TRUE if successful, or FALSE on an error.

void GDALARUnlockBuffer | ( | GDALAsyncReaderH | hARIO | ) |

Unlock image buffer.

Releases a lock on the image buffer previously taken with LockBuffer().

This is the same as GDALAsyncReader::UnlockBuffer()

Parameters

  hARIO | handle to async reader.

GDALAsyncReaderH GDALBeginAsyncReader | ( | GDALDatasetH | hDS,
|  | int | nXOff,
|  | int | nYOff,
|  | int | nXSize,
|  | int | nYSize,
|  | void * | pBuf,
|  | int | nBufXSize,
|  | int | nBufYSize,
|  | GDALDataType | eBufType,
|  | int | nBandCount,
|  | int * | panBandMap,
|  | int | nPixelSpace,
|  | int | nLineSpace,
|  | int | nBandSpace,
|  | char ** | papszOptions
| ) |  |

Sets up an asynchronous data request.

This method establish an asynchronous raster read request for the indicated window on the dataset into the indicated buffer. The parameters for windowing, buffer size, buffer type and buffer organization are similar to those for GDALDataset::RasterIO(); however, this call only launches the request and filling the buffer is accomplished via calls to GetNextUpdatedRegion() on the return GDALAsyncReader session object.

Once all processing for the created session is complete, or if no further refinement of the request is required, the GDALAsyncReader object should be destroyed with the GDALDataset::EndAsyncReader() method.

Note that the data buffer (pData) will potentially continue to be updated as long as the session lives, but it is not deallocated when the session (GDALAsyncReader) is destroyed with EndAsyncReader(). It should be deallocated by the application at that point.

Additional information on asynchronous IO in GDAL may be found at: http://trac.osgeo.org/gdal/wiki/rfc24_progressive_data_support

This method is the same as the C++ GDALDataset::BeginAsyncReader() method.

Parameters

  hDS | handle to the dataset object.
  nXOff | The pixel offset to the top left corner of the region of the band to be accessed. This would be zero to start from the left side.
  nYOff | The line offset to the top left corner of the region of the band to be accessed. This would be zero to start from the top.
  nXSize | The width of the region of the band to be accessed in pixels.
  nYSize | The height of the region of the band to be accessed in lines.
  pBuf | The buffer into which the data should be read. This buffer must contain at least nBufXSize * nBufYSize * nBandCount words of type eBufType. It is organized in left to right,top to bottom pixel order. Spacing is controlled by the nPixelSpace, and nLineSpace parameters.
  nBufXSize | the width of the buffer image into which the desired region is to be read, or from which it is to be written.
  nBufYSize | the height of the buffer image into which the desired region is to be read, or from which it is to be written.
  eBufType | the type of the pixel values in the pData data buffer. The pixel values will automatically be translated to/from the GDALRasterBand data type as needed.
  nBandCount | the number of bands being read or written.
  panBandMap | the list of nBandCount band numbers being read/written. Note band numbers are 1 based. This may be NULL to select the first nBandCount bands.
  nPixelSpace | The byte offset from the start of one pixel value in pData to the start of the next pixel value within a scanline. If defaulted (0) the size of the datatype eBufType is used.
  nLineSpace | The byte offset from the start of one scanline in pData to the start of the next. If defaulted the size of the datatype eBufType * nBufXSize is used.
  nBandSpace | the byte offset from the start of one bands data to the start of the next. If defaulted (zero) the value will be nLineSpace * nBufYSize implying band sequential organization of the data buffer.
  papszOptions | Driver specific control options in a string list or NULL. Consult driver documentation for options supported.

Returns
  handle representing the request.

CPLErr GDALBuildOverviews | ( | GDALDatasetH | hDataset,
|  | const char * | pszResampling,
|  | int | nOverviews,
|  | int * | panOverviewList,
|  | int | nListBands,
|  | int * | panBandList,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressData
| ) |  |

Build raster overview(s)

See also
  GDALDataset::BuildOverviews()

int GDALCheckVersion | ( | int | nVersionMajor,
|  | int | nVersionMinor,
|  | const char * | pszCallingComponentName
| ) |  |

Return TRUE if GDAL library version at runtime matches nVersionMajor.nVersionMinor.

The purpose of this method is to ensure that calling code will run with the GDAL version it is compiled for. It is primarily intended for external plugins.

Parameters

  nVersionMajor | Major version to be tested against
  nVersionMinor | Minor version to be tested against
  pszCallingComponentName | If not NULL, in case of version mismatch, the method will issue a failure mentioning the name of the calling component.

Returns
  TRUE if GDAL library version at runtime matches nVersionMajor.nVersionMinor, FALSE otherwise.

GDALColorTableH GDALCloneColorTable | ( | GDALColorTableH | hTable | ) |

Make a copy of a color table.

This function is the same as the C++ method GDALColorTable::Clone()

void GDALClose | ( | GDALDatasetH | hDS | ) |

Close GDAL dataset.

For non-shared datasets (opened with GDALOpen()) the dataset is closed using the C++ "delete" operator, recovering all dataset related resources. For shared datasets (opened with GDALOpenShared()) the dataset is dereferenced, and closed only if the referenced count has dropped below 1.

Parameters

  hDS | The dataset to close. May be cast from a "GDALDataset *".

void GDALComposeGeoTransforms | ( | const double * | padfGT1,
|  | const double * | padfGT2,
|  | double * | padfGTOut
| ) |  |

Compose two geotransforms.

The resulting geotransform is the equivalent to padfGT1 and then padfGT2 being applied to a point.

Parameters

  padfGT1 | the first geotransform, six values.
  padfGT2 | the second geotransform, six values.
  padfGTOut | the output geotransform, six values, may safely be the same array as padfGT1 or padfGT2.

CPLErr GDALComputeBandStats | ( | GDALRasterBandH | hSrcBand,
|  | int | nSampleStep,
|  | double * | pdfMean,
|  | double * | pdfStdDev,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressData
| ) |  |

Undocumented.

Parameters

  hSrcBand | undocumented.
  nSampleStep | undocumented.
  pdfMean | undocumented.
  pdfStdDev | undocumented.
  pfnProgress | undocumented.
  pProgressData | undocumented.

Returns
  undocumented

void GDALComputeRasterMinMax | ( | GDALRasterBandH | hBand,
|  | int | bApproxOK,
|  | double | adfMinMax[2]
| ) |  |

Compute the min/max values for a band.

See also
  GDALRasterBand::ComputeRasterMinMax()

CPLErr GDALComputeRasterStatistics | ( | GDALRasterBandH | hBand,
|  | int | bApproxOK,
|  | double * | pdfMin,
|  | double * | pdfMax,
|  | double * | pdfMean,
|  | double * | pdfStdDev,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressData
| ) |  |

Compute image statistics.

See also
  GDALRasterBand::ComputeStatistics()

void GDALCopyBits | ( | const GByte * | pabySrcData,
|  | int | nSrcOffset,
|  | int | nSrcStep,
|  | GByte * | pabyDstData,
|  | int | nDstOffset,
|  | int | nDstStep,
|  | int | nBitCount,
|  | int | nStepCount
| ) |  |

Bitwise word copying.

A function for moving sets of partial bytes around. Loosely speaking this is a bitwise analog to GDALCopyWords().

It copies nStepCount "words" where each word is nBitCount bits long. The nSrcStep and nDstStep are the number of bits from the start of one word to the next (same as nBitCount if they are packed). The nSrcOffset and nDstOffset are the offset into the source and destination buffers to start at, also measured in bits.

All bit offsets are assumed to start from the high order bit in a byte (i.e. most significant bit first). Currently this function is not very optimized, but it may be improved for some common cases in the future as needed.

Parameters

  pabySrcData | the source data buffer.
  nSrcOffset | the offset (in bits) in pabySrcData to the start of the first word to copy.
  nSrcStep | the offset in bits from the start one source word to the start of the next.
  pabyDstData | the destination data buffer.
  nDstOffset | the offset (in bits) in pabyDstData to the start of the first word to copy over.
  nDstStep | the offset in bits from the start one word to the start of the next.
  nBitCount | the number of bits in a word to be copied.
  nStepCount | the number of words to copy.

CPLErr GDALCopyDatasetFiles | ( | GDALDriverH | hDriver,
|  | const char * | pszNewName,
|  | const char * | pszOldName
| ) |  |

Copy the files of a dataset.

See also
  GDALDriver::CopyFiles()

void GDALCopyWords | ( | const void *CPL_RESTRICT | pSrcData,
|  | GDALDataType | eSrcType,
|  | int | nSrcPixelStride,
|  | void *CPL_RESTRICT | pDstData,
|  | GDALDataType | eDstType,
|  | int | nDstPixelStride,
|  | int | nWordCount
| ) |  |

Copy pixel words from buffer to buffer.

This function is used to copy pixel word values from one memory buffer to another, with support for conversion between data types, and differing step factors. The data type conversion is done using the normal GDAL rules. Values assigned to a lower range integer type are clipped. For instance assigning GDT_Int16 values to a GDT_Byte buffer will cause values less the 0 to be set to 0, and values larger than 255 to be set to 255. Assignment from floating point to integer uses default C type casting semantics. Assignment from non-complex to complex will result in the imaginary part being set to zero on output. Assignment from complex to non-complex will result in the complex portion being lost and the real component being preserved (not magnitidue!).

No assumptions are made about the source or destination words occurring on word boundaries. It is assumed that all values are in native machine byte order.

Parameters

  pSrcData | Pointer to source data to be converted.
  eSrcType | the source data type (see GDALDataType enum)
  nSrcPixelStride | Source pixel stride (i.e. distance between 2 words), in bytes
  pDstData | Pointer to buffer where destination data should go
  eDstType | the destination data type (see GDALDataType enum)
  nDstPixelStride | Destination pixel stride (i.e. distance between 2 words), in bytes
  nWordCount | number of words to be copied

Note
  When adding a new data type to GDAL, you must do the following to support it properly within the GDALCopyWords function:
  1. Add the data type to the switch on eSrcType in GDALCopyWords. This should invoke the appropriate GDALCopyWordsFromT wrapper.
  2. Add the data type to the switch on eDstType in GDALCopyWordsFromT. This should call the appropriate GDALCopyWordsT template.
  3. If appropriate, overload the appropriate CopyWord template in the above namespace. This will ensure that any conversion issues are handled (cases like the float -> int32 case, where the min/max) values are subject to roundoff error.

GDALDatasetH GDALCreate | ( | GDALDriverH | hDriver,
|  | const char * | pszFilename,
|  | int | nXSize,
|  | int | nYSize,
|  | int | nBands,
|  | GDALDataType | eBandType,
|  | char ** | papszOptions
| ) |  |

Create a new dataset with this driver.

See also
  GDALDriver::Create()

void GDALCreateColorRamp | ( | GDALColorTableH | hTable,
|  | int | nStartIndex,
|  | const GDALColorEntry * | psStartColor,
|  | int | nEndIndex,
|  | const GDALColorEntry * | psEndColor
| ) |  |

Create color ramp.

This function is the same as the C++ method GDALColorTable::CreateColorRamp()

GDALColorTableH GDALCreateColorTable | ( | GDALPaletteInterp | eInterp | ) |

Construct a new color table.

This function is the same as the C++ method GDALColorTable::GDALColorTable()

GDALDatasetH GDALCreateCopy | ( | GDALDriverH | hDriver,
|  | const char * | pszFilename,
|  | GDALDatasetH | hSrcDS,
|  | int | bStrict,
|  | char ** | papszOptions,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressData
| ) |  |

Create a copy of a dataset.

See also
  GDALDriver::CreateCopy()

CPLErr GDALCreateDatasetMaskBand | ( | GDALDatasetH | hDS,
|  | int | nFlags
| ) |  |

Adds a mask band to the dataset.

See also
  GDALDataset::CreateMaskBand()

CPLErr GDALCreateMaskBand | ( | GDALRasterBandH | hBand,
|  | int | nFlags
| ) |  |

Adds a mask band to the current band.

See also
  GDALRasterBand::CreateMaskBand()

GDALDatasetH GDALCreatePansharpenedVRT | ( | const char * | pszXML,
|  | GDALRasterBandH | hPanchroBand,
|  | int | nInputSpectralBands,
|  | GDALRasterBandH * | pahInputSpectralBands
| ) |  |

Create a virtual pansharpened dataset.

This function will create a virtual pansharpened dataset.

Note that no reference will be taken on the passed bands. Consequently, they or their dataset to which they belong to must be kept open until this virtual pansharpened dataset is closed.

The returned dataset will have no associated filename for itself. If you want to write the virtual dataset description to a file, use the GDALSetDescription() function (or SetDescription() method) on the dataset to assign a filename before it is closed.

Parameters

  pszXML | Pansharpened VRT XML where <SpectralBand> elements have no explicit SourceFilename and SourceBand. The spectral bands in the XML will be assigned the successive values of the pahInputSpectralBands array. Must not be NULL.
  hPanchroBand | Panchromatic band. Must not be NULL.
  nInputSpectralBands | Number of input spectral bands. Must be greater than zero.
  pahInputSpectralBands | Array of nInputSpectralBands spectral bands.

Returns
  NULL on failure, or a new virtual dataset handle on success to be closed with GDALClose().

Since
  GDAL 2.1

GDALRasterAttributeTableH GDALCreateRasterAttributeTable | ( | void |  | ) |

Construct empty table.

This function is the same as the C++ method GDALDefaultRasterAttributeTable::GDALDefaultRasterAttributeTable()

CPLErr GDALDatasetAdviseRead | ( | GDALDatasetH | hDS,
|  | int | nXOff,
|  | int | nYOff,
|  | int | nXSize,
|  | int | nYSize,
|  | int | nBufXSize,
|  | int | nBufYSize,
|  | GDALDataType | eDT,
|  | int | nBandCount,
|  | int * | panBandMap,
|  | char ** | papszOptions
| ) |  |

Advise driver of upcoming read requests.

See also
  GDALDataset::AdviseRead()

OGRErr GDALDatasetCommitTransaction | ( | GDALDatasetH | hDS | ) |

For datasources which support transactions, CommitTransaction commits a transaction.

If no transaction is active, or the commit fails, will return OGRERR_FAILURE. Datasources which do not support transactions will always return OGRERR_UNSUPPORTED_OPERATION.

Depending on drivers, this may or may not abort layer sequential readings that are active.

This function is the same as the C++ method GDALDataset::CommitTransaction()

Returns
  OGRERR_NONE on success.

Since
  GDAL 2.0

OGRLayerH GDALDatasetCopyLayer | ( | GDALDatasetH | hDS,
|  | OGRLayerH | hSrcLayer,
|  | const char * | pszNewName,
|  | char ** | papszOptions
| ) |  |

Duplicate an existing layer.

This function creates a new layer, duplicate the field definitions of the source layer and then duplicate each features of the source layer. The papszOptions argument can be used to control driver specific creation options. These options are normally documented in the format specific documentation. The source layer may come from another dataset.

This method is the same as the C++ method GDALDataset::CopyLayer()

Since
  GDAL 2.0

Parameters

  hDS | the dataset handle.
  hSrcLayer | source layer.
  pszNewName | the name of the layer to create.
  papszOptions | a StringList of name=value options. Options are driver specific.

Returns
  an handle to the layer, or NULL if an error occurs.

CPLErr GDALDatasetCopyWholeRaster | ( | GDALDatasetH | hSrcDS,
|  | GDALDatasetH | hDstDS,
|  | char ** | papszOptions,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressData
| ) |  |

Copy all dataset raster data.

This function copies the complete raster contents of one dataset to another similarly configured dataset. The source and destination dataset must have the same number of bands, and the same width and height. The bands do not have to have the same data type.

This function is primarily intended to support implementation of driver specific CreateCopy() functions. It implements efficient copying, in particular "chunking" the copy in substantial blocks and, if appropriate, performing the transfer in a pixel interleaved fashion.

Currently the only papszOptions value supported are :

- "INTERLEAVE=PIXEL" to force pixel interleaved operation
- "COMPRESSED=YES" to force alignment on target dataset block sizes to achieve best compression.
- "SKIP_HOLES=YES" to skip chunks for which GDALGetDataCoverageStatus() returns GDAL_DATA_COVERAGE_STATUS_EMPTY (GDAL >= 2.2)

More options may be supported in the future.

Parameters

  hSrcDS | the source dataset
  hDstDS | the destination dataset
  papszOptions | transfer hints in "StringList" Name=Value format.
  pfnProgress | progress reporting function.
  pProgressData | callback data for progress function.

Returns
  CE_None on success, or CE_Failure on failure.

OGRLayerH GDALDatasetCreateLayer | ( | GDALDatasetH | hDS,
|  | const char * | pszName,
|  | OGRSpatialReferenceH | hSpatialRef,
|  | OGRwkbGeometryType | eGType,
|  | char ** | papszOptions
| ) |  |

This function attempts to create a new layer on the dataset with the indicated name, coordinate system, geometry type.

The papszOptions argument can be used to control driver specific creation options. These options are normally documented in the format specific documentation.

This method is the same as the C++ method GDALDataset::CreateLayer().

Since
  GDAL 2.0

Parameters

  hDS | the dataset handle
  pszName | the name for the new layer. This should ideally not match any existing layer on the datasource.
  hSpatialRef | the coordinate system to use for the new layer, or NULL if no coordinate system is available.
  eGType | the geometry type for the layer. Use wkbUnknown if there are no constraints on the types geometry to be written.
  papszOptions | a StringList of name=value options. Options are driver specific.

Returns
  NULL is returned on failure, or a new OGRLayer handle on success.

Example:

1 #include "gdal.h"
2 #include "cpl_string.h"
3
4 ...
5
6 OGRLayer *poLayer;
7 char **papszOptions;
8
9 if( !poDS->TestCapability( ODsCCreateLayer ) )
10 {
11 ...
12 }
13
14 papszOptions = CSLSetNameValue( papszOptions, "DIM", "2" );
15 poLayer = poDS->CreateLayer( "NewLayer", NULL, wkbUnknown,
16 papszOptions );
17 CSLDestroy( papszOptions );
18
19 if( poLayer == NULL )
20 {
21 ...
22 }

OGRErr GDALDatasetDeleteLayer | ( | GDALDatasetH | hDS,
|  | int | iLayer
| ) |  |

Delete the indicated layer from the datasource.

If this function is supported the ODsCDeleteLayer capability will test TRUE on the GDALDataset.

This method is the same as the C++ method GDALDataset::DeleteLayer().

Since
  GDAL 2.0

Parameters

  hDS | the dataset handle.
  iLayer | the index of the layer to delete.

Returns
  OGRERR_NONE on success, or OGRERR_UNSUPPORTED_OPERATION if deleting layers is not supported for this datasource.

OGRLayerH GDALDatasetExecuteSQL | ( | GDALDatasetH | hDS,
|  | const char * | pszStatement,
|  | OGRGeometryH | hSpatialFilter,
|  | const char * | pszDialect
| ) |  |

Execute an SQL statement against the data store.

The result of an SQL query is either NULL for statements that are in error, or that have no results set, or an OGRLayer pointer representing a results set from the query. Note that this OGRLayer is in addition to the layers in the data store and must be destroyed with ReleaseResultSet() before the dataset is closed (destroyed).

This method is the same as the C++ method GDALDataset::ExecuteSQL()

For more information on the SQL dialect supported internally by OGR review the OGR SQL document. Some drivers (i.e. Oracle and PostGIS) pass the SQL directly through to the underlying RDBMS.

Starting with OGR 1.10, the SQLITE dialect can also be used.

Since
  GDAL 2.0

Parameters

  hDS | the dataset handle.
  pszStatement | the SQL statement to execute.
  hSpatialFilter | geometry which represents a spatial filter. Can be NULL.
  pszDialect | allows control of the statement dialect. If set to NULL, the OGR SQL engine will be used, except for RDBMS drivers that will use their dedicated SQL engine, unless OGRSQL is explicitly passed as the dialect. Starting with OGR 1.10, the SQLITE dialect can also be used.

Returns
  an OGRLayer containing the results of the query. Deallocate with ReleaseResultSet().

OGRLayerH GDALDatasetGetLayer | ( | GDALDatasetH | hDS,
|  | int | iLayer
| ) |  |

Fetch a layer by index.

The returned layer remains owned by the GDALDataset and should not be deleted by the application.

This function is the same as the C++ method GDALDataset::GetLayer()

Since
  GDAL 2.0

Parameters

  hDS | the dataset handle.
  iLayer | a layer number between 0 and GetLayerCount()-1.

Returns
  the layer, or NULL if iLayer is out of range or an error occurs.

OGRLayerH GDALDatasetGetLayerByName | ( | GDALDatasetH | hDS,
|  | const char * | pszName
| ) |  |

Fetch a layer by name.

The returned layer remains owned by the GDALDataset and should not be deleted by the application.

This function is the same as the C++ method GDALDataset::GetLayerByName()

Since
  GDAL 2.0

Parameters

  hDS | the dataset handle.
  pszName | the layer name of the layer to fetch.

Returns
  the layer, or NULL if Layer is not found or an error occurs.

int GDALDatasetGetLayerCount | ( | GDALDatasetH | hDS | ) |

Get the number of layers in this dataset.

This function is the same as the C++ method GDALDataset::GetLayerCount()

Since
  GDAL 2.0

Parameters

  hDS | the dataset handle.

Returns
  layer count.

OGRFeatureH GDALDatasetGetNextFeature | ( | GDALDatasetH | hDS,
|  | OGRLayerH * | phBelongingLayer,
|  | double * | pdfProgressPct,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressData
| ) |  |

Fetch the next available feature from this dataset.

This method is intended for the few drivers where OGR_L_GetNextFeature() is not efficient, but in general OGR_L_GetNextFeature() is a more natural API.

The returned feature becomes the responsibility of the caller to delete with OGRFeature::DestroyFeature().

Depending on the driver, this method may return features from layers in a non sequential way. This is what may happen when the ODsCRandomLayerRead capability is declared (for example for the OSM and GMLAS drivers). When datasets declare this capability, it is strongly advised to use GDALDataset::GetNextFeature() instead of OGRLayer::GetNextFeature(), as the later might have a slow, incomplete or stub implementation.

The default implementation, used by most drivers, will however iterate over each layer, and then over each feature within this layer.

This method takes into account spatial and attribute filters set on layers that will be iterated upon.

The ResetReading() method can be used to start at the beginning again.

Depending on drivers, this may also have the side effect of calling OGRLayer::GetNextFeature() on the layers of this dataset.

This method is the same as the C++ method GDALDataset::GetNextFeature()

Parameters

  hDS | dataset handle.
  phBelongingLayer | a pointer to a OGRLayer* variable to receive the layer to which the object belongs to, or NULL. It is possible that the output of *ppoBelongingLayer to be NULL despite the feature not being NULL.
  pdfProgressPct | a pointer to a double variable to receive the percentage progress (in [0,1] range), or NULL. On return, the pointed value might be negative if determining the progress is not possible.
  pfnProgress | a progress callback to report progress (for GetNextFeature() calls that might have a long duration) and offer cancellation possibility, or NULL
  pProgressData | user data provided to pfnProgress, or NULL

Returns
  a feature, or NULL if no more features are available.

Since
  GDAL 2.2

OGRStyleTableH GDALDatasetGetStyleTable | ( | GDALDatasetH | hDS | ) |

Returns dataset style table.

This function is the same as the C++ method GDALDataset::GetStyleTable()

Since
  GDAL 2.0

Parameters

  hDS | the dataset handle

Returns
  handle to a style table which should not be modified or freed by the caller.

CPLVirtualMem* GDALDatasetGetTiledVirtualMem | ( | GDALDatasetH | hDS,
|  | GDALRWFlag | eRWFlag,
|  | int | nXOff,
|  | int | nYOff,
|  | int | nXSize,
|  | int | nYSize,
|  | int | nTileXSize,
|  | int | nTileYSize,
|  | GDALDataType | eBufType,
|  | int | nBandCount,
|  | int * | panBandMap,
|  | GDALTileOrganization | eTileOrganization,
|  | size_t | nCacheSize,
|  | int | bSingleThreadUsage,
|  | char ** | papszOptions
| ) |  |

Create a CPLVirtualMem object from a GDAL dataset object, with tiling organization.

Only supported on Linux for now.

This method allows creating a virtual memory object for a region of one or more GDALRasterBands from this dataset. The content of the virtual memory object is automatically filled from dataset content when a virtual memory page is first accessed, and it is released (or flushed in case of a "dirty" page) when the cache size limit has been reached.

Contrary to GDALDatasetGetVirtualMem(), pixels will be organized by tiles instead of scanlines. Different ways of organizing pixel within/across tiles can be selected with the eTileOrganization parameter.

If nXSize is not a multiple of nTileXSize or nYSize is not a multiple of nTileYSize, partial tiles will exists at the right and/or bottom of the region of interest. Those partial tiles will also have nTileXSize * nTileYSize dimension, with padding pixels.

The pointer to access the virtual memory object is obtained with CPLVirtualMemGetAddr(). It remains valid until CPLVirtualMemFree() is called. CPLVirtualMemFree() must be called before the dataset object is destroyed.

If p is such a pointer and base_type the C type matching eBufType, for default values of spacing parameters, the element of image coordinates (x, y) (relative to xOff, yOff) for band b can be accessed with:

- for eTileOrganization = GTO_TIP, ((base_type*)p)[tile_number(x,y)*nBandCount*tile_size + offset_in_tile(x,y)*nBandCount + (b-1)].
- for eTileOrganization = GTO_BIT, ((base_type*)p)[(tile_number(x,y)*nBandCount + (b-1)) * tile_size + offset_in_tile(x,y)].
- for eTileOrganization = GTO_BSQ, ((base_type*)p)[(tile_number(x,y) + (b-1)*nTilesCount) * tile_size + offset_in_tile(x,y)].

where nTilesPerRow = ceil(nXSize / nTileXSize) nTilesPerCol = ceil(nYSize / nTileYSize) nTilesCount = nTilesPerRow * nTilesPerCol tile_number(x,y) = (y / nTileYSize) * nTilesPerRow + (x / nTileXSize) offset_in_tile(x,y) = (y % nTileYSize) * nTileXSize + (x % nTileXSize) tile_size = nTileXSize * nTileYSize

Note that for a single band request, all tile organizations are equivalent.

Note that the mechanism used to transparently fill memory pages when they are accessed is the same (but in a controlled way) than what occurs when a memory error occurs in a program. Debugging software will generally interrupt program execution when that happens. If needed, CPLVirtualMemPin() can be used to avoid that by ensuring memory pages are allocated before being accessed.

The size of the region that can be mapped as a virtual memory object depends on hardware and operating system limitations. On Linux AMD64 platforms, the maximum value is 128 TB. On Linux x86 platforms, the maximum value is 2 GB.

Data type translation is automatically done if the data type (eBufType) of the buffer is different than that of the GDALRasterBand.

Parameters

  hDS | Dataset object
  eRWFlag | Either GF_Read to read a region of data, or GF_Write to write a region of data.
  nXOff | The pixel offset to the top left corner of the region of the band to be accessed. This would be zero to start from the left side.
  nYOff | The line offset to the top left corner of the region of the band to be accessed. This would be zero to start from the top.
  nXSize | The width of the region of the band to be accessed in pixels.
  nYSize | The height of the region of the band to be accessed in lines.
  nTileXSize | the width of the tiles.
  nTileYSize | the height of the tiles.
  eBufType | the type of the pixel values in the data buffer. The pixel values will automatically be translated to/from the GDALRasterBand data type as needed.
  nBandCount | the number of bands being read or written.
  panBandMap | the list of nBandCount band numbers being read/written. Note band numbers are 1 based. This may be NULL to select the first nBandCount bands.
  eTileOrganization | tile organization.
  nCacheSize | size in bytes of the maximum memory that will be really allocated (must ideally fit into RAM)
  bSingleThreadUsage | set to TRUE if there will be no concurrent threads that will access the virtual memory mapping. This can optimize performance a bit. If set to FALSE, CPLVirtualMemDeclareThread() must be called.
  papszOptions | NULL terminated list of options. Unused for now.

Returns
  a virtual memory object that must be freed by CPLVirtualMemFree(), or NULL in case of failure.

Since
  GDAL 1.11

CPLVirtualMem* GDALDatasetGetVirtualMem | ( | GDALDatasetH | hDS,
|  | GDALRWFlag | eRWFlag,
|  | int | nXOff,
|  | int | nYOff,
|  | int | nXSize,
|  | int | nYSize,
|  | int | nBufXSize,
|  | int | nBufYSize,
|  | GDALDataType | eBufType,
|  | int | nBandCount,
|  | int * | panBandMap,
|  | int | nPixelSpace,
|  | GIntBig | nLineSpace,
|  | GIntBig | nBandSpace,
|  | size_t | nCacheSize,
|  | size_t | nPageSizeHint,
|  | int | bSingleThreadUsage,
|  | char ** | papszOptions
| ) |  |

Create a CPLVirtualMem object from a GDAL dataset object.

Only supported on Linux for now.

This method allows creating a virtual memory object for a region of one or more GDALRasterBands from this dataset. The content of the virtual memory object is automatically filled from dataset content when a virtual memory page is first accessed, and it is released (or flushed in case of a "dirty" page) when the cache size limit has been reached.

The pointer to access the virtual memory object is obtained with CPLVirtualMemGetAddr(). It remains valid until CPLVirtualMemFree() is called. CPLVirtualMemFree() must be called before the dataset object is destroyed.

If p is such a pointer and base_type the C type matching eBufType, for default values of spacing parameters, the element of image coordinates (x, y) (relative to xOff, yOff) for band b can be accessed with ((base_type*)p)[x + y * nBufXSize + (b-1)*nBufXSize*nBufYSize].

Note that the mechanism used to transparently fill memory pages when they are accessed is the same (but in a controlled way) than what occurs when a memory error occurs in a program. Debugging software will generally interrupt program execution when that happens. If needed, CPLVirtualMemPin() can be used to avoid that by ensuring memory pages are allocated before being accessed.

The size of the region that can be mapped as a virtual memory object depends on hardware and operating system limitations. On Linux AMD64 platforms, the maximum value is 128 TB. On Linux x86 platforms, the maximum value is 2 GB.

Data type translation is automatically done if the data type (eBufType) of the buffer is different than that of the GDALRasterBand.

Image decimation / replication is currently not supported, i.e. if the size of the region being accessed (nXSize x nYSize) is different from the buffer size (nBufXSize x nBufYSize).

The nPixelSpace, nLineSpace and nBandSpace parameters allow reading into or writing from various organization of buffers. Arbitrary values for the spacing parameters are not supported. Those values must be multiple of the size of thebuffer data type, and must be either band sequential organization (typically nPixelSpace = GDALGetDataTypeSizeBytes(eBufType), nLineSpace = nPixelSpace * nBufXSize, nBandSpace = nLineSpace * nBufYSize), or pixel-interleaved organization (typically nPixelSpace = nBandSpace * nBandCount, nLineSpace = nPixelSpace * nBufXSize, nBandSpace = GDALGetDataTypeSizeBytes(eBufType))

Parameters

  hDS | Dataset object
  eRWFlag | Either GF_Read to read a region of data, or GF_Write to write a region of data.
  nXOff | The pixel offset to the top left corner of the region of the band to be accessed. This would be zero to start from the left side.
  nYOff | The line offset to the top left corner of the region of the band to be accessed. This would be zero to start from the top.
  nXSize | The width of the region of the band to be accessed in pixels.
  nYSize | The height of the region of the band to be accessed in lines.
  nBufXSize | the width of the buffer image into which the desired region is to be read, or from which it is to be written.
  nBufYSize | the height of the buffer image into which the desired region is to be read, or from which it is to be written.
  eBufType | the type of the pixel values in the data buffer. The pixel values will automatically be translated to/from the GDALRasterBand data type as needed.
  nBandCount | the number of bands being read or written.
  panBandMap | the list of nBandCount band numbers being read/written. Note band numbers are 1 based. This may be NULL to select the first nBandCount bands.
  nPixelSpace | The byte offset from the start of one pixel value in the buffer to the start of the next pixel value within a scanline. If defaulted (0) the size of the datatype eBufType is used.
  nLineSpace | The byte offset from the start of one scanline in the buffer to the start of the next. If defaulted (0) the size of the datatype eBufType * nBufXSize is used.
  nBandSpace | the byte offset from the start of one bands data to the start of the next. If defaulted (0) the value will be nLineSpace * nBufYSize implying band sequential organization of the data buffer.
  nCacheSize | size in bytes of the maximum memory that will be really allocated (must ideally fit into RAM)
  nPageSizeHint | hint for the page size. Must be a multiple of the system page size, returned by CPLGetPageSize(). Minimum value is generally 4096. Might be set to 0 to let the function determine a default page size.
  bSingleThreadUsage | set to TRUE if there will be no concurrent threads that will access the virtual memory mapping. This can optimize performance a bit. If set to FALSE, CPLVirtualMemDeclareThread() must be called.
  papszOptions | NULL terminated list of options. Unused for now.

Returns
  a virtual memory object that must be freed by CPLVirtualMemFree(), or NULL in case of failure.

Since
  GDAL 1.11

CPLErr GDALDatasetRasterIO | ( | GDALDatasetH | hDS,
|  | GDALRWFlag | eRWFlag,
|  | int | nXOff,
|  | int | nYOff,
|  | int | nXSize,
|  | int | nYSize,
|  | void * | pData,
|  | int | nBufXSize,
|  | int | nBufYSize,
|  | GDALDataType | eBufType,
|  | int | nBandCount,
|  | int * | panBandMap,
|  | int | nPixelSpace,
|  | int | nLineSpace,
|  | int | nBandSpace
| ) |  |

Read/write a region of image data from multiple bands.

Use GDALDatasetRasterIOEx() if 64 bit spacings or extra arguments (resampling resolution, progress callback, etc. are needed)

See also
  GDALDataset::RasterIO()

CPLErr GDALDatasetRasterIOEx | ( | GDALDatasetH | hDS,
|  | GDALRWFlag | eRWFlag,
|  | int | nXOff,
|  | int | nYOff,
|  | int | nXSize,
|  | int | nYSize,
|  | void * | pData,
|  | int | nBufXSize,
|  | int | nBufYSize,
|  | GDALDataType | eBufType,
|  | int | nBandCount,
|  | int * | panBandMap,
|  | GSpacing | nPixelSpace,
|  | GSpacing | nLineSpace,
|  | GSpacing | nBandSpace,
|  | GDALRasterIOExtraArg * | psExtraArg
| ) |  |

Read/write a region of image data from multiple bands.

See also
  GDALDataset::RasterIO()

Since
  GDAL 2.0

void GDALDatasetReleaseResultSet | ( | GDALDatasetH | hDS,
|  | OGRLayerH | hLayer
| ) |  |

Release results of ExecuteSQL().

This function should only be used to deallocate OGRLayers resulting from an ExecuteSQL() call on the same GDALDataset. Failure to deallocate a results set before destroying the GDALDataset may cause errors.

This function is the same as the C++ method GDALDataset::ReleaseResultSet()

Since
  GDAL 2.0

Parameters

  hDS | the dataset handle.
  hLayer | the result of a previous ExecuteSQL() call.

void GDALDatasetResetReading | ( | GDALDatasetH | hDS | ) |

Reset feature reading to start on the first feature.

This affects GDALDatasetGetNextFeature().

Depending on drivers, this may also have the side effect of calling OGR_L_ResetReading() on the layers of this dataset.

This method is the same as the C++ method GDALDataset::ResetReading()

Parameters

  hDS | dataset handle

Since
  GDAL 2.2

OGRErr GDALDatasetRollbackTransaction | ( | GDALDatasetH | hDS | ) |

For datasources which support transactions, RollbackTransaction will roll back a datasource to its state before the start of the current transaction.

If no transaction is active, or the rollback fails, will return OGRERR_FAILURE. Datasources which do not support transactions will always return OGRERR_UNSUPPORTED_OPERATION.

This function is the same as the C++ method GDALDataset::RollbackTransaction().

Returns
  OGRERR_NONE on success.

Since
  GDAL 2.0

void GDALDatasetSetStyleTable | ( | GDALDatasetH | hDS,
|  | OGRStyleTableH | hStyleTable
| ) |  |

Set dataset style table.

This function operate exactly as GDALDatasetSetStyleTableDirectly() except that it assumes ownership of the passed table.

This function is the same as the C++ method GDALDataset::SetStyleTable()

Since
  GDAL 2.0

Parameters

  hDS | the dataset handle
  hStyleTable | style table handle to set

void GDALDatasetSetStyleTableDirectly | ( | GDALDatasetH | hDS,
|  | OGRStyleTableH | hStyleTable
| ) |  |

Set dataset style table.

This function operate exactly as GDALDatasetSetStyleTable() except that it assumes ownership of the passed table.

This function is the same as the C++ method GDALDataset::SetStyleTableDirectly()

Since
  GDAL 2.0

Parameters

  hDS | the dataset handle
  hStyleTable | style table handle to set

OGRErr GDALDatasetStartTransaction | ( | GDALDatasetH | hDS,
|  | int | bForce
| ) |  |

For datasources which support transactions, StartTransaction creates a transaction.

If starting the transaction fails, will return OGRERR_FAILURE. Datasources which do not support transactions will always return OGRERR_UNSUPPORTED_OPERATION.

Nested transactions are not supported.

All changes done after the start of the transaction are definitely applied in the datasource if CommitTransaction() is called. They may be canceled by calling RollbackTransaction() instead.

At the time of writing, transactions only apply on vector layers.

Datasets that support transactions will advertise the ODsCTransactions capability. Use of transactions at dataset level is generally preferred to transactions at layer level, whose scope is rarely limited to the layer from which it was started.

In case StartTransaction() fails, neither CommitTransaction() or RollbackTransaction() should be called.

If an error occurs after a successful StartTransaction(), the whole transaction may or may not be implicitly canceled, depending on drivers. (e.g. the PG driver will cancel it, SQLite/GPKG not). In any case, in the event of an error, an explicit call to RollbackTransaction() should be done to keep things balanced.

By default, when bForce is set to FALSE, only "efficient" transactions will be attempted. Some drivers may offer an emulation of transactions, but sometimes with significant overhead, in which case the user must explicitly allow for such an emulation by setting bForce to TRUE. Drivers that offer emulated transactions should advertise the ODsCEmulatedTransactions capability (and not ODsCTransactions).

This function is the same as the C++ method GDALDataset::StartTransaction()

Parameters

  hDS | the dataset handle.
  bForce | can be set to TRUE if an emulation, possibly slow, of a transaction mechanism is acceptable.

Returns
  OGRERR_NONE on success.

Since
  GDAL 2.0

int GDALDatasetTestCapability | ( | GDALDatasetH | hDS,
|  | const char * | pszCap
| ) |  |

Test if capability is available.

One of the following dataset capability names can be passed into this function, and a TRUE or FALSE value will be returned indicating whether or not the capability is available for this object.

- ODsCCreateLayer: True if this datasource can create new layers.

- ODsCDeleteLayer: True if this datasource can delete existing layers.

- ODsCCreateGeomFieldAfterCreateLayer: True if the layers of this datasource support CreateGeomField() just after layer creation.

- ODsCCurveGeometries: True if this datasource supports curve geometries.

- ODsCTransactions: True if this datasource supports (efficient) transactions.

- ODsCEmulatedTransactions: True if this datasource supports transactions through emulation.

- ODsCRandomLayerRead: True if this datasource has a dedicated GetNextFeature() implementation, potentially returning features from layers in a non sequential way.

- ODsCRandomLayerWrite: True if this datasource supports calling CreateFeature() on layers in a non sequential way.

The #define macro forms of the capability names should be used in preference to the strings themselves to avoid misspelling.

This function is the same as the C++ method GDALDataset::TestCapability()

Since
  GDAL 2.0

Parameters

  hDS | the dataset handle.
  pszCap | the capability to test.

Returns
  TRUE if capability available otherwise FALSE.

int GDALDataTypeIsComplex | ( | GDALDataType | eDataType | ) |

Is data type complex?

Returns
  TRUE if the passed type is complex (one of GDT_CInt16, GDT_CInt32, GDT_CFloat32 or GDT_CFloat64), that is it consists of a real and imaginary component.

GDALDataType GDALDataTypeUnion | ( | GDALDataType | eType1,
|  | GDALDataType | eType2
| ) |  |

Return the smallest data type that can fully express both input data types.

Parameters

  eType1 | first data type.
  eType2 | second data type.

Returns
  a data type able to express eType1 and eType2.

double GDALDecToPackedDMS | ( | double | dfDec | ) |

Convert decimal degrees into packed DMS value (DDDMMMSSS.SS).

See CPLDecToPackedDMS().

void GDALDeinitGCPs | ( | int | nCount,
|  | GDAL_GCP * | psGCP
| ) |  |

De-initialize an array of GCPs (initialized with GDALInitGCPs())

Parameters

  nCount | number of GCPs in psGCP
  psGCP | array of GCPs of size nCount.

CPLErr GDALDeleteDataset | ( | GDALDriverH | hDriver,
|  | const char * | pszFilename
| ) |  |

Delete named dataset.

See also
  GDALDriver::Delete()

CPLErr GDALDeleteRasterNoDataValue | ( | GDALRasterBandH | hBand | ) |

Remove the no data value for this band.

See also
  GDALRasterBand::DeleteNoDataValue()

Since
  GDAL 2.1

int GDALDereferenceDataset | ( | GDALDatasetH | hDataset | ) |

Subtract one from dataset reference count.

See also
  GDALDataset::Dereference()

void GDALDeregisterDriver | ( | GDALDriverH | hDriver | ) |

Deregister the passed driver.

See also
  GDALDriverManager::GetDeregisterDriver()

void GDALDestroyColorTable | ( | GDALColorTableH | hTable | ) |

Destroys a color table.

This function is the same as the C++ method GDALColorTable::~GDALColorTable()

void GDALDestroyDriver | ( | GDALDriverH | hDriver | ) |

Destroy a GDALDriver.

This is roughly equivalent to deleting the driver, but is guaranteed to take place in the GDAL heap. It is important this that function not be called on a driver that is registered with the GDALDriverManager.

Parameters

  hDriver | the driver to destroy.

void GDALDestroyDriverManager | ( | void |  | ) |

Destroy the driver manager.

Incidentally unloads all managed drivers.

NOTE: This function is not thread safe. It should not be called while other threads are actively using GDAL.

void GDALDestroyRasterAttributeTable | ( | GDALRasterAttributeTableH | hRAT | ) |

Destroys a RAT.

This function is the same as the C++ method GDALRasterAttributeTable::~GDALRasterAttributeTable()

int GDALDumpOpenDatasets | ( | FILE * | fp | ) |

List open datasets.

Dumps a list of all open datasets (shared or not) to the indicated text file (may be stdout or stderr). This function is primarily intended to assist in debugging "dataset leaks" and reference counting issues. The information reported includes the dataset name, referenced count, shared status, driver name, size, and band count.

GDAL_GCP* GDALDuplicateGCPs | ( | int | nCount,
|  | const GDAL_GCP * | pasGCPList
| ) |  |

Duplicate an array of GCPs.

The return must be freed with GDALDeinitGCPs() followed by CPLFree()

Parameters

  nCount | number of GCPs in psGCP
  pasGCPList | array of GCPs of size nCount.

void GDALEndAsyncReader | ( | GDALDatasetH | hDS,
|  | GDALAsyncReaderH | hAsyncReaderH
| ) |  |

End asynchronous request.

This method destroys an asynchronous io request and recovers all resources associated with it.

This method is the same as the C++ method GDALDataset::EndAsyncReader().

Parameters

  hDS | handle to the dataset object.
  hAsyncReaderH | handle returned by GDALBeginAsyncReader()

int GDALExtractRPCInfo | ( | char ** | papszMD,
|  | GDALRPCInfo * | psRPC
| ) |  |

Extract RPC info from metadata, and apply to an RPCInfo structure.

The inverse of this function is RPCInfoToMD() in alg/gdal_rpc.cpp

Parameters

  papszMD | Dictionary of metadata representing RPC
  psRPC | (output) Pointer to structure to hold the RPC values.

Returns
  TRUE in case of success. FALSE in case of failure.

CPLErr GDALFillRaster | ( | GDALRasterBandH | hBand,
|  | double | dfRealValue,
|  | double | dfImaginaryValue
| ) |  |

Fill this band with a constant value.

See also
  GDALRasterBand::Fill()

void GDALFlushCache | ( | GDALDatasetH | hDS | ) |

Flush all write cached data to disk.

See also
  GDALDataset::FlushCache().

int GDALFlushCacheBlock | ( | void |  | ) |

Try to flush one cached raster block.

This function will search the first unlocked raster block and will flush it to release the associated memory.

Returns
  TRUE if one block was flushed, FALSE if there are no cached blocks or if they are currently locked.

CPLErr GDALFlushRasterCache | ( | GDALRasterBandH | hBand | ) |

Flush raster data cache.

See also
  GDALRasterBand::FlushCache()

int GDALGCPsToGeoTransform | ( | int | nGCPCount,
|  | const GDAL_GCP * | pasGCPs,
|  | double * | padfGeoTransform,
|  | int | bApproxOK
| ) |  |

Generate Geotransform from GCPs.

Given a set of GCPs perform first order fit as a geotransform.

Due to imprecision in the calculations the fit algorithm will often return non-zero rotational coefficients even if given perfectly non-rotated inputs. A special case has been implemented for corner corner coordinates given in TL, TR, BR, BL order. So when using this to get a geotransform from 4 corner coordinates, pass them in this order.

Parameters

  nGCPCount | the number of GCPs being passed in.
  pasGCPs | the list of GCP structures.
  padfGeoTransform | the six double array in which the affine geotransformation will be returned.
  bApproxOK | If FALSE the function will fail if the geotransform is not essentially an exact fit (within 0.25 pixel) for all GCPs.

Returns
  TRUE on success or FALSE if there aren't enough points to prepare a geotransform, the pointers are ill-determined or if bApproxOK is FALSE and the fit is poor.

int GDALGeneralCmdLineProcessor | ( | int | nArgc,
|  | char *** | ppapszArgv,
|  | int | nOptions
| ) |  |

General utility option processing.

This function is intended to provide a variety of generic commandline options for all GDAL commandline utilities. It takes care of the following commandline options:

–version: report version of GDAL in use. –build: report build info about GDAL in use. –license: report GDAL license info. –formats: report all format drivers configured. –format [format]: report details of one format driver. –optfile filename: expand an option file into the argument list. –config key value: set system configuration option. –debug [on/off/value]: set debug level. –mempreload dir: preload directory contents into /vsimem –pause: Pause for user input (allows time to attach debugger) –locale [locale]: Install a locale using setlocale() (debugging) –help-general: report detailed help on general options.

The argument array is replaced "in place" and should be freed with CSLDestroy() when no longer needed. The typical usage looks something like the following. Note that the formats should be registered so that the –formats and –format options will work properly.

int main( int argc, char ** argv ) { GDALAllRegister();

argc = GDALGeneralCmdLineProcessor( argc, &argv, 0 ); if( argc < 1 ) exit( -argc );

Parameters

  nArgc | number of values in the argument list.
  ppapszArgv | pointer to the argument list array (will be updated in place).
  nOptions | a or-able combination of GDAL_OF_RASTER and GDAL_OF_VECTOR to determine which drivers should be displayed by –formats. If set to 0, GDAL_OF_RASTER is assumed.

Returns
  updated nArgc argument count. Return of 0 requests terminate without error, return of -1 requests exit with error code.

int GDALGetAccess | ( | GDALDatasetH | hDS | ) |

Return access flag.

See also
  GDALDataset::GetAccess()

CPLErr GDALGetActualBlockSize | ( | GDALRasterBandH | hBand,
|  | int | nXBlockOff,
|  | int | nYBlockOff,
|  | int * | pnXValid,
|  | int * | pnYValid
| ) |  |

Retrieve the actual block size for a given block offset.

See also
  GDALRasterBand::GetActualBlockSize()

GDALAsyncStatusType GDALGetAsyncStatusTypeByName | ( | const char * | pszName | ) |

Get AsyncStatusType by symbolic name.

Returns a data type corresponding to the given symbolic name. This function is opposite to the GDALGetAsyncStatusTypeName().

Parameters

  pszName | string containing the symbolic name of the type.

Returns
  GDAL AsyncStatus type.

const char* GDALGetAsyncStatusTypeName | ( | GDALAsyncStatusType | eAsyncStatusType | ) |

Get name of AsyncStatus data type.

Returns a symbolic name for the AsyncStatus data type. This is essentially the the enumerated item name with the GARIO_ prefix removed. So GARIO_COMPLETE returns "COMPLETE". The returned strings are static strings and should not be modified or freed by the application. These strings are useful for reporting datatypes in debug statements, errors and other user output.

Parameters

  eAsyncStatusType | type to get name of.

Returns
  string corresponding to type.

GDALDatasetH GDALGetBandDataset | ( | GDALRasterBandH | hBand | ) |

Fetch the owning dataset handle.

See also
  GDALRasterBand::GetDataset()

int GDALGetBandNumber | ( | GDALRasterBandH | hBand | ) |

Fetch the band number.

See also
  GDALRasterBand::GetBand()

void GDALGetBlockSize | ( | GDALRasterBandH | hBand,
|  | int * | pnXSize,
|  | int * | pnYSize
| ) |  |

Fetch the "natural" block size of this band.

See also
  GDALRasterBand::GetBlockSize()

int GDALGetCacheMax | ( | void |  | ) |

Get maximum cache memory.

Gets the maximum amount of memory available to the GDALRasterBlock caching system for caching GDAL read/write imagery.

The first type this function is called, it will read the GDAL_CACHEMAX configuration option to initialize the maximum cache memory. Starting with GDAL 2.1, the value can be expressed as x% of the usable physical RAM (which may potentially be used by other processes). Otherwise it is expected to be a value in MB.

This function cannot return a value higher than 2 GB. Use GDALGetCacheMax64() to get a non-truncated value.

Returns
  maximum in bytes.

GIntBig GDALGetCacheMax64 | ( | void |  | ) |

Get maximum cache memory.

Gets the maximum amount of memory available to the GDALRasterBlock caching system for caching GDAL read/write imagery.

The first type this function is called, it will read the GDAL_CACHEMAX configuration option to initialize the maximum cache memory. Starting with GDAL 2.1, the value can be expressed as x% of the usable physical RAM (which may potentially be used by other processes). Otherwise it is expected to be a value in MB.

Returns
  maximum in bytes.

Since
  GDAL 1.8.0

int GDALGetCacheUsed | ( | void |  | ) |

Get cache memory used.

Returns
  the number of bytes of memory currently in use by the GDALRasterBlock memory caching.

GIntBig GDALGetCacheUsed64 | ( | void |  | ) |

Get cache memory used.

Returns
  the number of bytes of memory currently in use by the GDALRasterBlock memory caching.

Since
  GDAL 1.8.0

const GDALColorEntry* GDALGetColorEntry | ( | GDALColorTableH | hTable,
|  | int | i
| ) |  |

Fetch a color entry from table.

This function is the same as the C++ method GDALColorTable::GetColorEntry()

int GDALGetColorEntryAsRGB | ( | GDALColorTableH | hTable,
|  | int | i,
|  | GDALColorEntry * | poEntry
| ) |  |

Fetch a table entry in RGB format.

This function is the same as the C++ method GDALColorTable::GetColorEntryAsRGB().

int GDALGetColorEntryCount | ( | GDALColorTableH | hTable | ) |

Get number of color entries in table.

This function is the same as the C++ method GDALColorTable::GetColorEntryCount()

GDALColorInterp GDALGetColorInterpretationByName | ( | const char * | pszName | ) |

Get color interpretation by symbolic name.

Returns a color interpretation corresponding to the given symbolic name. This function is opposite to the GDALGetColorInterpretationName().

Parameters

  pszName | string containing the symbolic name of the color interpretation.

Returns
  GDAL color interpretation.

Since
  GDAL 1.7.0

const char* GDALGetColorInterpretationName | ( | GDALColorInterp | eInterp | ) |

Get name of color interpretation.

Returns a symbolic name for the color interpretation. This is derived from the enumerated item name with the GCI_ prefix removed, but there are some variations. So GCI_GrayIndex returns "Gray" and GCI_RedBand returns "Red". The returned strings are static strings and should not be modified or freed by the application.

Parameters

  eInterp | color interpretation to get name of.

Returns
  string corresponding to color interpretation or NULL pointer if invalid enumerator given.

int GDALGetDataCoverageStatus | ( | GDALRasterBandH | hBand,
|  | int | nXOff,
|  | int | nYOff,
|  | int | nXSize,
|  | int | nYSize,
|  | int | nMaskFlagStop,
|  | double * | pdfDataPct
| ) |  |

Get the coverage status of a sub-window of the raster.

Returns whether a sub-window of the raster contains only data, only empty blocks or a mix of both. This function can be used to determine quickly if it is worth issuing RasterIO / ReadBlock requests in datasets that may be sparse.

Empty blocks are blocks that are generally not physically present in the file, and when read through GDAL, contain only pixels whose value is the nodata value when it is set, or whose value is 0 when the nodata value is not set.

The query is done in an efficient way without reading the actual pixel values. If not possible, or not implemented at all by the driver, GDAL_DATA_COVERAGE_STATUS_UNIMPLEMENTED | GDAL_DATA_COVERAGE_STATUS_DATA will be returned.

The values that can be returned by the function are the following, potentially combined with the binary or operator :

- GDAL_DATA_COVERAGE_STATUS_UNIMPLEMENTED : the driver does not implement GetDataCoverageStatus(). This flag should be returned together with GDAL_DATA_COVERAGE_STATUS_DATA.
- GDAL_DATA_COVERAGE_STATUS_DATA: There is (potentially) data in the queried window.
- GDAL_DATA_COVERAGE_STATUS_EMPTY: There is nodata in the queried window. This is typically identified by the concept of missing block in formats that supports it.

Note that GDAL_DATA_COVERAGE_STATUS_DATA might have false positives and should be interpreted more as hint of potential presence of data. For example if a GeoTIFF file is created with blocks filled with zeroes (or set to the nodata value), instead of using the missing block mechanism, GDAL_DATA_COVERAGE_STATUS_DATA will be returned. On the contrary, GDAL_DATA_COVERAGE_STATUS_EMPTY should have no false positives.

The nMaskFlagStop should be generally set to 0. It can be set to a binary-or'ed mask of the above mentioned values to enable a quick exiting of the function as soon as the computed mask matches the nMaskFlagStop. For example, you can issue a request on the whole raster with nMaskFlagStop = GDAL_DATA_COVERAGE_STATUS_EMPTY. As soon as one missing block is encountered, the function will exit, so that you can potentially refine the requested area to find which particular region(s) have missing blocks.

See also
  GDALRasterBand::GetDataCoverageStatus()

Parameters

  hBand | raster band
  nXOff | The pixel offset to the top left corner of the region of the band to be queried. This would be zero to start from the left side.
  nYOff | The line offset to the top left corner of the region of the band to be queried. This would be zero to start from the top.
  nXSize | The width of the region of the band to be queried in pixels.
  nYSize | The height of the region of the band to be queried in lines.
  nMaskFlagStop | 0, or a binary-or'ed mask of possible values GDAL_DATA_COVERAGE_STATUS_UNIMPLEMENTED, GDAL_DATA_COVERAGE_STATUS_DATA and GDAL_DATA_COVERAGE_STATUS_EMPTY. As soon as the computation of the coverage matches the mask, the computation will be stopped. *pdfDataPct will not be valid in that case.
  pdfDataPct | Optional output parameter whose pointed value will be set to the (approximate) percentage in [0,100] of pixels in the queried sub-window that have valid values. The implementation might not always be able to compute it, in which case it will be set to a negative value.

Returns
  a binary-or'ed combination of possible values GDAL_DATA_COVERAGE_STATUS_UNIMPLEMENTED, GDAL_DATA_COVERAGE_STATUS_DATA and GDAL_DATA_COVERAGE_STATUS_EMPTY

Note
  Added in GDAL 2.2

GDALDriverH GDALGetDatasetDriver | ( | GDALDatasetH | hDataset | ) |

Fetch the driver to which this dataset relates.

See also
  GDALDataset::GetDriver()

GDALDataType GDALGetDataTypeByName | ( | const char * | pszName | ) |

Get data type by symbolic name.

Returns a data type corresponding to the given symbolic name. This function is opposite to the GDALGetDataTypeName().

Parameters

  pszName | string containing the symbolic name of the type.

Returns
  GDAL data type.

const char* GDALGetDataTypeName | ( | GDALDataType | eDataType | ) |

Get name of data type.

Returns a symbolic name for the data type. This is essentially the the enumerated item name with the GDT_ prefix removed. So GDT_Byte returns "Byte". The returned strings are static strings and should not be modified or freed by the application. These strings are useful for reporting datatypes in debug statements, errors and other user output.

Parameters

  eDataType | type to get name of.

Returns
  string corresponding to existing data type or NULL pointer if invalid type given.

int GDALGetDataTypeSize | ( | GDALDataType | eDataType | ) |

Get data type size in bits.

Deprecated.

Returns the size of a GDT_* type in bits, not bytes!

Use GDALGetDataTypeSizeBytes() for bytes. Use GDALGetDataTypeSizeBits() for bits.

Parameters

  eDataType | type, such as GDT_Byte.

Returns
  the number of bits or zero if it is not recognised.

int GDALGetDataTypeSizeBits | ( | GDALDataType | eDataType | ) |

Get data type size in bits.

Returns the size of a GDT_* type in bits, not bytes! Use GDALGetDataTypeSizeBytes() for bytes.

Parameters

  eDataType | type, such as GDT_Byte.

Returns
  the number of bits or zero if it is not recognised.

int GDALGetDataTypeSizeBytes | ( | GDALDataType | eDataType | ) |

Get data type size in bytes.

Returns the size of a GDT_* type in bytes. In contrast, GDALGetDataTypeBits() returns the size in bits.

Parameters

  eDataType | type, such as GDT_Byte.

Returns
  the number of bytes or zero if it is not recognised.

CPLErr GDALGetDefaultHistogram | ( | GDALRasterBandH | hBand,
|  | double * | pdfMin,
|  | double * | pdfMax,
|  | int * | pnBuckets,
|  | int ** | ppanHistogram,
|  | int | bForce,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressData
| ) |  |

Fetch default raster histogram.

Use GDALGetRasterHistogramEx() instead to get correct counts for values exceeding 2 billion.

See also
  GDALRasterBand::GDALGetDefaultHistogram()
  GDALGetRasterHistogramEx()

CPLErr GDALGetDefaultHistogramEx | ( | GDALRasterBandH | hBand,
|  | double * | pdfMin,
|  | double * | pdfMax,
|  | int * | pnBuckets,
|  | GUIntBig ** | ppanHistogram,
|  | int | bForce,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressData
| ) |  |

Fetch default raster histogram.

See also
  GDALRasterBand::GetDefaultHistogram()

Since
  GDAL 2.0

GDALRasterAttributeTableH GDALGetDefaultRAT | ( | GDALRasterBandH | hBand | ) |

Fetch default Raster Attribute Table.

See also
  GDALRasterBand::GetDefaultRAT()

const char* GDALGetDescription | ( | GDALMajorObjectH | hObject | ) |

Fetch object description.

See also
  GDALMajorObject::GetDescription()

GDALDriverH GDALGetDriver | ( | int | iDriver | ) |

Fetch driver by index.

See also
  GDALDriverManager::GetDriver()

GDALDriverH GDALGetDriverByName | ( | const char * | pszName | ) |

Fetch a driver based on the short name.

See also
  GDALDriverManager::GetDriverByName()

int GDALGetDriverCount | ( | void |  | ) |

Fetch the number of registered drivers.

See also
  GDALDriverManager::GetDriverCount()

const char* GDALGetDriverCreationOptionList | ( | GDALDriverH | hDriver | ) |

Return the list of creation options of the driver.

Return the list of creation options of the driver used by Create() and CreateCopy() as an XML string

Parameters

  hDriver | the handle of the driver

Returns
  an XML string that describes the list of creation options or empty string. The returned string should not be freed and is owned by the driver.

const char* GDALGetDriverHelpTopic | ( | GDALDriverH | hDriver | ) |

Return the URL to the help that describes the driver.

That URL is relative to the GDAL documentation directory.

For the GeoTIFF driver, this is "frmt_gtiff.html"

Parameters

  hDriver | the handle of the driver

Returns
  the URL to the help that describes the driver or NULL. The returned string should not be freed and is owned by the driver.

const char* GDALGetDriverLongName | ( | GDALDriverH | hDriver | ) |

Return the long name of a driver.

For the GeoTIFF driver, this is "GeoTIFF"

Parameters

  hDriver | the handle of the driver

Returns
  the long name of the driver or empty string. The returned string should not be freed and is owned by the driver.

const char* GDALGetDriverShortName | ( | GDALDriverH | hDriver | ) |

Return the short name of a driver.

This is the string that can be passed to the GDALGetDriverByName() function.

For the GeoTIFF driver, this is "GTiff"

Parameters

  hDriver | the handle of the driver

Returns
  the short name of the driver. The returned string should not be freed and is owned by the driver.

char** GDALGetFileList | ( | GDALDatasetH | hDS | ) |

Fetch files forming dataset.

See also
  GDALDataset::GetFileList()

int GDALGetGCPCount | ( | GDALDatasetH | hDS | ) |

Get number of GCPs.

See also
  GDALDataset::GetGCPCount()

const char* GDALGetGCPProjection | ( | GDALDatasetH | hDS | ) |

Get output projection for GCPs.

See also
  GDALDataset::GetGCPProjection()

const GDAL_GCP* GDALGetGCPs | ( | GDALDatasetH | hDS | ) |

Fetch GCPs.

See also
  GDALDataset::GetGCPs()

CPLErr GDALGetGeoTransform | ( | GDALDatasetH | hDS,
|  | double * | padfTransform
| ) |  |

Fetch the affine transformation coefficients.

See also
  GDALDataset::GetGeoTransform()

void* GDALGetInternalHandle | ( | GDALDatasetH | hDS,
|  | const char * | pszRequest
| ) |  |

Fetch a format specific internally meaningful handle.

See also
  GDALDataset::GetInternalHandle()

CPLXMLNode* GDALGetJPEG2000Structure | ( | const char * | pszFilename,
|  | char ** | papszOptions
| ) |  |

Dump the structure of a JPEG2000 file as a XML tree.

Parameters

  pszFilename | filename.
  papszOptions | NULL terminated list of options, or NULL. Allowed options are BINARY_CONTENT=YES, TEXT_CONTENT=YES, CODESTREAM=YES, ALL=YES.

Returns
  XML tree (to be freed with CPLDestroyXMLNode()) or NULL in case of error

Since
  GDAL 2.0

GDALRasterBandH GDALGetMaskBand | ( | GDALRasterBandH | hBand | ) |

Return the mask band associated with the band.

See also
  GDALRasterBand::GetMaskBand()

int GDALGetMaskFlags | ( | GDALRasterBandH | hBand | ) |

Return the status flags of the mask band associated with the band.

See also
  GDALRasterBand::GetMaskFlags()

char** GDALGetMetadata | ( | GDALMajorObjectH | hObject,
|  | const char * | pszDomain
| ) |  |

Fetch metadata.

See also
  GDALMajorObject::GetMetadata()

char** GDALGetMetadataDomainList | ( | GDALMajorObjectH | hObject | ) |

Fetch list of metadata domains.

See also
  GDALMajorObject::GetMetadataDomainList()

Since
  GDAL 1.11

const char* GDALGetMetadataItem | ( | GDALMajorObjectH | hObject,
|  | const char * | pszName,
|  | const char * | pszDomain
| ) |  |

Fetch single metadata item.

See also
  GDALMajorObject::GetMetadataItem()

GDALDataType GDALGetNonComplexDataType | ( | GDALDataType | eDataType | ) |

Return the base data type for the specified input.

If the input data type is complex this function returns the base type i.e. the data type of the real and imaginary parts (non-complex). If the input data type is already non-complex, then it is returned unchanged.

Parameters

  eDataType | type, such as GDT_CFloat32.

Returns
  GDAL data type.

void GDALGetOpenDatasets | ( | GDALDatasetH ** | ppahDSList,
|  | int * | pnCount
| ) |  |

Fetch all open GDAL dataset handles.

See also
  GDALDataset::GetOpenDatasets()

GDALRasterBandH GDALGetOverview | ( | GDALRasterBandH | hBand,
|  | int | i
| ) |  |

Fetch overview raster band object.

See also
  GDALRasterBand::GetOverview()

int GDALGetOverviewCount | ( | GDALRasterBandH | hBand | ) |

Return the number of overview layers available.

See also
  GDALRasterBand::GetOverviewCount()

GDALPaletteInterp GDALGetPaletteInterpretation | ( | GDALColorTableH | hTable | ) |

Fetch palette interpretation.

This function is the same as the C++ method GDALColorTable::GetPaletteInterpretation()

const char* GDALGetPaletteInterpretationName | ( | GDALPaletteInterp | eInterp | ) |

Get name of palette interpretation.

Returns a symbolic name for the palette interpretation. This is the the enumerated item name with the GPI_ prefix removed. So GPI_Gray returns "Gray". The returned strings are static strings and should not be modified or freed by the application.

Parameters

  eInterp | palette interpretation to get name of.

Returns
  string corresponding to palette interpretation.

const char* GDALGetProjectionRef | ( | GDALDatasetH | hDS | ) |

Fetch the projection definition string for this dataset.

See also
  GDALDataset::GetProjectionRef()

int GDALGetRandomRasterSample | ( | GDALRasterBandH | hBand,
|  | int | nSamples,
|  | float * | pafSampleBuf
| ) |  |

Undocumented.

Parameters

  hBand | undocumented.
  nSamples | undocumented.
  pafSampleBuf | undocumented.

Returns
  undocumented

GDALAccess GDALGetRasterAccess | ( | GDALRasterBandH | hBand | ) |

Find out if we have update permission for this band.

See also
  GDALRasterBand::GetAccess()

GDALRasterBandH GDALGetRasterBand | ( | GDALDatasetH | hDS,
|  | int | nBandId
| ) |  |

Fetch a band object for a dataset.

See also
  GDALDataset::GetRasterBand().

int GDALGetRasterBandXSize | ( | GDALRasterBandH | hBand | ) |

Fetch XSize of raster.

See also
  GDALRasterBand::GetXSize()

int GDALGetRasterBandYSize | ( | GDALRasterBandH | hBand | ) |

Fetch YSize of raster.

See also
  GDALRasterBand::GetYSize()

char** GDALGetRasterCategoryNames | ( | GDALRasterBandH | hBand | ) |

Fetch the list of category names for this raster.

See also
  GDALRasterBand::GetCategoryNames()

GDALColorInterp GDALGetRasterColorInterpretation | ( | GDALRasterBandH | hBand | ) |

How should this band be interpreted as color?

See also
  GDALRasterBand::GetColorInterpretation()

GDALColorTableH GDALGetRasterColorTable | ( | GDALRasterBandH | hBand | ) |

Fetch the color table associated with band.

See also
  GDALRasterBand::GetColorTable()

int GDALGetRasterCount | ( | GDALDatasetH | hDS | ) |

Fetch the number of raster bands on this dataset.

See also
  GDALDataset::GetRasterCount().

GDALDataType GDALGetRasterDataType | ( | GDALRasterBandH | hBand | ) |

Fetch the pixel data type for this band.

See also
  GDALRasterBand::GetRasterDataType()

CPLErr GDALGetRasterHistogram | ( | GDALRasterBandH | hBand,
|  | double | dfMin,
|  | double | dfMax,
|  | int | nBuckets,
|  | int * | panHistogram,
|  | int | bIncludeOutOfRange,
|  | int | bApproxOK,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressData
| ) |  |

Compute raster histogram.

Use GDALGetRasterHistogramEx() instead to get correct counts for values exceeding 2 billion.

See also
  GDALRasterBand::GetHistogram()
  GDALGetRasterHistogramEx()

CPLErr GDALGetRasterHistogramEx | ( | GDALRasterBandH | hBand,
|  | double | dfMin,
|  | double | dfMax,
|  | int | nBuckets,
|  | GUIntBig * | panHistogram,
|  | int | bIncludeOutOfRange,
|  | int | bApproxOK,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressData
| ) |  |

Compute raster histogram.

See also
  GDALRasterBand::GetHistogram()

Since
  GDAL 2.0

double GDALGetRasterMaximum | ( | GDALRasterBandH | hBand,
|  | int * | pbSuccess
| ) |  |

Fetch the maximum value for this band.

See also
  GDALRasterBand::GetMaximum()

double GDALGetRasterMinimum | ( | GDALRasterBandH | hBand,
|  | int * | pbSuccess
| ) |  |

Fetch the minimum value for this band.

See also
  GDALRasterBand::GetMinimum()

double GDALGetRasterNoDataValue | ( | GDALRasterBandH | hBand,
|  | int * | pbSuccess
| ) |  |

Fetch the no data value for this band.

See also
  GDALRasterBand::GetNoDataValue()

double GDALGetRasterOffset | ( | GDALRasterBandH | hBand,
|  | int * | pbSuccess
| ) |  |

Fetch the raster value offset.

See also
  GDALRasterBand::GetOffset()

GDALRasterBandH GDALGetRasterSampleOverview | ( | GDALRasterBandH | hBand,
|  | int | nDesiredSamples
| ) |  |

Fetch best sampling overview.

Use GDALGetRasterSampleOverviewEx() to be able to specify more than 2 billion samples.

See also
  GDALRasterBand::GetRasterSampleOverview()
  GDALGetRasterSampleOverviewEx()

GDALRasterBandH GDALGetRasterSampleOverviewEx | ( | GDALRasterBandH | hBand,
|  | GUIntBig | nDesiredSamples
| ) |  |

Fetch best sampling overview.

See also
  GDALRasterBand::GetRasterSampleOverview()

Since
  GDAL 2.0

double GDALGetRasterScale | ( | GDALRasterBandH | hBand,
|  | int * | pbSuccess
| ) |  |

Fetch the raster value scale.

See also
  GDALRasterBand::GetScale()

CPLErr GDALGetRasterStatistics | ( | GDALRasterBandH | hBand,
|  | int | bApproxOK,
|  | int | bForce,
|  | double * | pdfMin,
|  | double * | pdfMax,
|  | double * | pdfMean,
|  | double * | pdfStdDev
| ) |  |

Fetch image statistics.

See also
  GDALRasterBand::GetStatistics()

const char* GDALGetRasterUnitType | ( | GDALRasterBandH | hBand | ) |

Return raster unit type.

See also
  GDALRasterBand::GetUnitType()

int GDALGetRasterXSize | ( | GDALDatasetH | hDataset | ) |

Fetch raster width in pixels.

See also
  GDALDataset::GetRasterXSize().

int GDALGetRasterYSize | ( | GDALDatasetH | hDataset | ) |

Fetch raster height in pixels.

See also
  GDALDataset::GetRasterYSize().

CPLVirtualMem* GDALGetVirtualMemAuto | ( | GDALRasterBandH | hBand,
|  | GDALRWFlag | eRWFlag,
|  | int * | pnPixelSpace,
|  | GIntBig * | pnLineSpace,
|  | char ** | papszOptions
| ) |  |

Create a CPLVirtualMem object from a GDAL raster band object.

See also
  GDALRasterBand::GetVirtualMemAuto()

int GDALHasArbitraryOverviews | ( | GDALRasterBandH | hBand | ) |

Check for arbitrary overviews.

See also
  GDALRasterBand::HasArbitraryOverviews()

GDALDriverH GDALIdentifyDriver | ( | const char * | pszFilename,
|  | char ** | papszFileList
| ) |  |

Identify the driver that can open a raster file.

This function will try to identify the driver that can open the passed file name by invoking the Identify method of each registered GDALDriver in turn. The first driver that successful identifies the file name will be returned. If all drivers fail then NULL is returned.

In order to reduce the need for such searches touch the operating system file system machinery, it is possible to give an optional list of files. This is the list of all files at the same level in the file system as the target file, including the target file. The filenames will not include any path components, are essentially just the output of VSIReadDir() on the parent directory. If the target object does not have filesystem semantics then the file list should be NULL.

Parameters

  pszFilename | the name of the file to access. In the case of exotic drivers this may not refer to a physical file, but instead contain information for the driver on how to access a dataset.
  papszFileList | an array of strings, whose last element is the NULL pointer. These strings are filenames that are auxiliary to the main filename. The passed value may be NULL.

Returns
  A GDALDriverH handle or NULL on failure. For C++ applications this handle can be cast to a GDALDriver *.

GDALDriverH GDALIdentifyDriverEx | ( | const char * | pszFilename,
|  | unsigned int | nIdentifyFlags,
|  | const char *const * | papszAllowedDrivers,
|  | const char *const * | papszFileList
| ) |  |

Identify the driver that can open a raster file.

This function will try to identify the driver that can open the passed file name by invoking the Identify method of each registered GDALDriver in turn. The first driver that successful identifies the file name will be returned. If all drivers fail then NULL is returned.

In order to reduce the need for such searches touch the operating system file system machinery, it is possible to give an optional list of files. This is the list of all files at the same level in the file system as the target file, including the target file. The filenames will not include any path components, are essentially just the output of VSIReadDir() on the parent directory. If the target object does not have filesystem semantics then the file list should be NULL.

Parameters

  pszFilename | the name of the file to access. In the case of exotic drivers this may not refer to a physical file, but instead contain information for the driver on how to access a dataset.
  nIdentifyFlags | a combination of GDAL_OF_RASTER for raster drivers or GDAL_OF_VECTOR for vector drivers. If none of the value is specified, both kinds are implied.
  papszAllowedDrivers | NULL to consider all candidate drivers, or a NULL terminated list of strings with the driver short names that must be considered.
  papszFileList | an array of strings, whose last element is the NULL pointer. These strings are filenames that are auxiliary to the main filename. The passed value may be NULL.

Returns
  A GDALDriverH handle or NULL on failure. For C++ applications this handle can be cast to a GDALDriver *.

Since
  GDAL 2.2

void GDALInitGCPs | ( | int | nCount,
|  | GDAL_GCP * | psGCP
| ) |  |

Initialize an array of GCPs.

Numeric values are initialized to 0 and strings to the empty string "" allocated with CPLStrdup() An array initialized with GDALInitGCPs() must be de-initialized with GDALDeinitGCPs().

Parameters

  nCount | number of GCPs in psGCP
  psGCP | array of GCPs of size nCount.

int GDALInvGeoTransform | ( | double * | gt_in,
|  | double * | gt_out
| ) |  |

Invert Geotransform.

This function will invert a standard 3x2 set of GeoTransform coefficients. This converts the equation from being pixel to geo to being geo to pixel.

Parameters

  gt_in | Input geotransform (six doubles - unaltered).
  gt_out | Output geotransform (six doubles - updated).

Returns
  TRUE on success or FALSE if the equation is uninvertable.

int GDALLoadOziMapFile | ( | const char * | pszFilename,
|  | double * | padfGeoTransform,
|  | char ** | ppszWKT,
|  | int * | pnGCPCount,
|  | GDAL_GCP ** | ppasGCPs
| ) |  |

Helper function for translator implementer wanting support for OZI .map.

Parameters

  pszFilename | filename of .tab file
  padfGeoTransform | output geotransform. Must hold 6 doubles.
  ppszWKT | output pointer to a string that will be allocated with CPLMalloc().
  pnGCPCount | output pointer to GCP count.
  ppasGCPs | outputer pointer to an array of GCPs.

Returns
  TRUE in case of success, FALSE otherwise.

int GDALLoadTabFile | ( | const char * | pszFilename,
|  | double * | padfGeoTransform,
|  | char ** | ppszWKT,
|  | int * | pnGCPCount,
|  | GDAL_GCP ** | ppasGCPs
| ) |  |

Helper function for translator implementer wanting support for MapInfo .tab files.

Parameters

  pszFilename | filename of .tab
  padfGeoTransform | output geotransform. Must hold 6 doubles.
  ppszWKT | output pointer to a string that will be allocated with CPLMalloc().
  pnGCPCount | output pointer to GCP count.
  ppasGCPs | outputer pointer to an array of GCPs.

Returns
  TRUE in case of success, FALSE otherwise.

int GDALLoadWorldFile | ( | const char * | pszFilename,
|  | double * | padfGeoTransform
| ) |  |

Read ESRI world file.

This function reads an ESRI style world file, and formats a geotransform from its contents.

The world file contains an affine transformation with the parameters in a different order than in a geotransform array.

- geotransform[1] : width of pixel
- geotransform[4] : rotational coefficient, zero for north up images.
- geotransform[2] : rotational coefficient, zero for north up images.
- geotransform[5] : height of pixel (but negative)
- geotransform[0] + 0.5 * geotransform[1] + 0.5 * geotransform[2] : x offset to center of top left pixel.
- geotransform[3] + 0.5 * geotransform[4] + 0.5 * geotransform[5] : y offset to center of top left pixel.

Parameters

  pszFilename | the world file name.
  padfGeoTransform | the six double array into which the geotransformation should be placed.

Returns
  TRUE on success or FALSE on failure.

GDALDatasetH GDALOpen | ( | const char * | pszFilename,
|  | GDALAccess | eAccess
| ) |  |

Open a raster file as a GDALDataset.

This function will try to open the passed file, or virtual dataset name by invoking the Open method of each registered GDALDriver in turn. The first successful open will result in a returned dataset. If all drivers fail then NULL is returned and an error is issued.

Several recommendations :

- If you open a dataset object with GA_Update access, it is not recommended to open a new dataset on the same underlying file.
- The returned dataset should only be accessed by one thread at a time. If you want to use it from different threads, you must add all necessary code (mutexes, etc.) to avoid concurrent use of the object. (Some drivers, such as GeoTIFF, maintain internal state variables that are updated each time a new block is read, thus preventing concurrent use.)

For drivers supporting the VSI virtual file API, it is possible to open a file in a .zip archive (see VSIInstallZipFileHandler()), in a .tar/.tar.gz/.tgz archive (see VSIInstallTarFileHandler()) or on a HTTP / FTP server (see VSIInstallCurlFileHandler())

In some situations (dealing with unverified data), the datasets can be opened in another process through the GDAL API Proxy mechanism.

See also
  GDALOpenShared()
  GDALOpenEx()

Parameters

  pszFilename | the name of the file to access. In the case of exotic drivers this may not refer to a physical file, but instead contain information for the driver on how to access a dataset. It should be in UTF-8 encoding.
  eAccess | the desired access, either GA_Update or GA_ReadOnly. Many drivers support only read only access.

Returns
  A GDALDatasetH handle or NULL on failure. For C++ applications this handle can be cast to a GDALDataset *.

GDALDatasetH GDALOpenEx | ( | const char * | pszFilename,
|  | unsigned int | nOpenFlags,
|  | const char *const * | papszAllowedDrivers,
|  | const char *const * | papszOpenOptions,
|  | const char *const * | papszSiblingFiles
| ) |  |

Open a raster or vector file as a GDALDataset.

This function will try to open the passed file, or virtual dataset name by invoking the Open method of each registered GDALDriver in turn. The first successful open will result in a returned dataset. If all drivers fail then NULL is returned and an error is issued.

Several recommendations :

- If you open a dataset object with GDAL_OF_UPDATE access, it is not recommended to open a new dataset on the same underlying file.
- The returned dataset should only be accessed by one thread at a time. If you want to use it from different threads, you must add all necessary code (mutexes, etc.) to avoid concurrent use of the object. (Some drivers, such as GeoTIFF, maintain internal state variables that are updated each time a new block is read, thus preventing concurrent use.)

For drivers supporting the VSI virtual file API, it is possible to open a file in a .zip archive (see VSIInstallZipFileHandler()), in a .tar/.tar.gz/.tgz archive (see VSIInstallTarFileHandler()) or on a HTTP / FTP server (see VSIInstallCurlFileHandler())

In some situations (dealing with unverified data), the datasets can be opened in another process through the GDAL API Proxy mechanism.

In order to reduce the need for searches through the operating system file system machinery, it is possible to give an optional list of files with the papszSiblingFiles parameter. This is the list of all files at the same level in the file system as the target file, including the target file. The filenames must not include any path components, are essentially just the output of VSIReadDir() on the parent directory. If the target object does not have filesystem semantics then the file list should be NULL.

Parameters

  pszFilename | the name of the file to access. In the case of exotic drivers this may not refer to a physical file, but instead contain information for the driver on how to access a dataset. It should be in UTF-8 encoding.
  nOpenFlags | a combination of GDAL_OF_ flags that may be combined through logical or operator. Driver kind: GDAL_OF_RASTER for raster drivers, GDAL_OF_VECTOR for vector drivers. If none of the value is specified, both kinds are implied. Access mode: GDAL_OF_READONLY (exclusive)or GDAL_OF_UPDATE. Shared mode: GDAL_OF_SHARED. If set, it allows the sharing of GDALDataset handles for a dataset with other callers that have set GDAL_OF_SHARED. In particular, GDALOpenEx() will first consult its list of currently open and shared GDALDataset's, and if the GetDescription() name for one exactly matches the pszFilename passed to GDALOpenEx() it will be referenced and returned, if GDALOpenEx() is called from the same thread. Verbose error: GDAL_OF_VERBOSE_ERROR. If set, a failed attempt to open the file will lead to an error message to be reported.
  papszAllowedDrivers | NULL to consider all candidate drivers, or a NULL terminated list of strings with the driver short names that must be considered.
  papszOpenOptions | NULL, or a NULL terminated list of strings with open options passed to candidate drivers. An option exists for all drivers, OVERVIEW_LEVEL=level, to select a particular overview level of a dataset. The level index starts at 0. The level number can be suffixed by "only" to specify that only this overview level must be visible, and not sub-levels. Open options are validated by default, and a warning is emitted in case the option is not recognized. In some scenarios, it might be not desirable (e.g. when not knowing which driver will open the file), so the special open option VALIDATE_OPEN_OPTIONS can be set to NO to avoid such warnings. Alternatively, since GDAL 2.1, an option name can be preceded by the @ character to indicate that it may not cause a warning if the driver doesn't declare this option.
  papszSiblingFiles | NULL, or a NULL terminated list of strings that are filenames that are auxiliary to the main filename. If NULL is passed, a probing of the file system will be done.

Returns
  A GDALDatasetH handle or NULL on failure. For C++ applications this handle can be cast to a GDALDataset *.

Since
  GDAL 2.0

GDALDatasetH GDALOpenShared | ( | const char * | pszFilename,
|  | GDALAccess | eAccess
| ) |  |

Open a raster file as a GDALDataset.

This function works the same as GDALOpen(), but allows the sharing of GDALDataset handles for a dataset with other callers to GDALOpenShared().

In particular, GDALOpenShared() will first consult its list of currently open and shared GDALDataset's, and if the GetDescription() name for one exactly matches the pszFilename passed to GDALOpenShared() it will be referenced and returned.

Starting with GDAL 1.6.0, if GDALOpenShared() is called on the same pszFilename from two different threads, a different GDALDataset object will be returned as it is not safe to use the same dataset from different threads, unless the user does explicitly use mutexes in its code.

For drivers supporting the VSI virtual file API, it is possible to open a file in a .zip archive (see VSIInstallZipFileHandler()), in a .tar/.tar.gz/.tgz archive (see VSIInstallTarFileHandler()) or on a HTTP / FTP server (see VSIInstallCurlFileHandler())

In some situations (dealing with unverified data), the datasets can be opened in another process through the GDAL API Proxy mechanism.

See also
  GDALOpen()
  GDALOpenEx()

Parameters

  pszFilename | the name of the file to access. In the case of exotic drivers this may not refer to a physical file, but instead contain information for the driver on how to access a dataset. It should be in UTF-8 encoding.
  eAccess | the desired access, either GA_Update or GA_ReadOnly. Many drivers support only read only access.

Returns
  A GDALDatasetH handle or NULL on failure. For C++ applications this handle can be cast to a GDALDataset *.

CPLErr GDALOverviewMagnitudeCorrection | ( | GDALRasterBandH | hBaseBand,
|  | int | nOverviewCount,
|  | GDALRasterBandH * | pahOverviews,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressData
| ) |  |

Undocumented.

Parameters

  hBaseBand | undocumented.
  nOverviewCount | undocumented.
  pahOverviews | undocumented.
  pfnProgress | undocumented.
  pProgressData | undocumented.

Returns
  undocumented

double GDALPackedDMSToDec | ( | double | dfPacked | ) |

Convert a packed DMS value (DDDMMMSSS.SS) into decimal degrees.

See CPLPackedDMSToDec().

CPLErr GDALRasterAdviseRead | ( | GDALRasterBandH | hBand,
|  | int | nXOff,
|  | int | nYOff,
|  | int | nXSize,
|  | int | nYSize,
|  | int | nBufXSize,
|  | int | nBufYSize,
|  | GDALDataType | eDT,
|  | char ** | papszOptions
| ) |  |

Advise driver of upcoming read requests.

See also
  GDALRasterBand::AdviseRead()

CPLErr GDALRasterBandCopyWholeRaster | ( | GDALRasterBandH | hSrcBand,
|  | GDALRasterBandH | hDstBand,
|  | const char *const *const | papszOptions,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressData
| ) |  |

Copy all raster band raster data.

This function copies the complete raster contents of one band to another similarly configured band. The source and destination bands must have the same width and height. The bands do not have to have the same data type.

It implements efficient copying, in particular "chunking" the copy in substantial blocks.

Currently the only papszOptions value supported are :

- "COMPRESSED=YES" to force alignment on target dataset block sizes to achieve best compression.
- "SKIP_HOLES=YES" to skip chunks for which GDALGetDataCoverageStatus() returns GDAL_DATA_COVERAGE_STATUS_EMPTY (GDAL >= 2.2)

Parameters

  hSrcBand | the source band
  hDstBand | the destination band
  papszOptions | transfer hints in "StringList" Name=Value format.
  pfnProgress | progress reporting function.
  pProgressData | callback data for progress function.

Returns
  CE_None on success, or CE_Failure on failure.

CPLVirtualMem* GDALRasterBandGetTiledVirtualMem | ( | GDALRasterBandH | hBand,
|  | GDALRWFlag | eRWFlag,
|  | int | nXOff,
|  | int | nYOff,
|  | int | nXSize,
|  | int | nYSize,
|  | int | nTileXSize,
|  | int | nTileYSize,
|  | GDALDataType | eBufType,
|  | size_t | nCacheSize,
|  | int | bSingleThreadUsage,
|  | char ** | papszOptions
| ) |  |

Create a CPLVirtualMem object from a GDAL rasterband object, with tiling organization.

Only supported on Linux for now.

This method allows creating a virtual memory object for a region of one GDALRasterBand. The content of the virtual memory object is automatically filled from dataset content when a virtual memory page is first accessed, and it is released (or flushed in case of a "dirty" page) when the cache size limit has been reached.

Contrary to GDALDatasetGetVirtualMem(), pixels will be organized by tiles instead of scanlines.

If nXSize is not a multiple of nTileXSize or nYSize is not a multiple of nTileYSize, partial tiles will exists at the right and/or bottom of the region of interest. Those partial tiles will also have nTileXSize * nTileYSize dimension, with padding pixels.

The pointer to access the virtual memory object is obtained with CPLVirtualMemGetAddr(). It remains valid until CPLVirtualMemFree() is called. CPLVirtualMemFree() must be called before the raster band object is destroyed.

If p is such a pointer and base_type the C type matching eBufType, for default values of spacing parameters, the element of image coordinates (x, y) (relative to xOff, yOff) can be accessed with: ((base_type*)p)[tile_number(x,y)*tile_size + offset_in_tile(x,y)].

where nTilesPerRow = ceil(nXSize / nTileXSize) nTilesCount = nTilesPerRow * nTilesPerCol tile_number(x,y) = (y / nTileYSize) * nTilesPerRow + (x / nTileXSize) offset_in_tile(x,y) = (y % nTileYSize) * nTileXSize + (x % nTileXSize) tile_size = nTileXSize * nTileYSize

Note that the mechanism used to transparently fill memory pages when they are accessed is the same (but in a controlled way) than what occurs when a memory error occurs in a program. Debugging software will generally interrupt program execution when that happens. If needed, CPLVirtualMemPin() can be used to avoid that by ensuring memory pages are allocated before being accessed.

The size of the region that can be mapped as a virtual memory object depends on hardware and operating system limitations. On Linux AMD64 platforms, the maximum value is 128 TB. On Linux x86 platforms, the maximum value is 2 GB.

Data type translation is automatically done if the data type (eBufType) of the buffer is different than that of the GDALRasterBand.

Parameters

  hBand | Rasterband object
  eRWFlag | Either GF_Read to read a region of data, or GF_Write to write a region of data.
  nXOff | The pixel offset to the top left corner of the region of the band to be accessed. This would be zero to start from the left side.
  nYOff | The line offset to the top left corner of the region of the band to be accessed. This would be zero to start from the top.
  nXSize | The width of the region of the band to be accessed in pixels.
  nYSize | The height of the region of the band to be accessed in lines.
  nTileXSize | the width of the tiles.
  nTileYSize | the height of the tiles.
  eBufType | the type of the pixel values in the data buffer. The pixel values will automatically be translated to/from the GDALRasterBand data type as needed.
  nCacheSize | size in bytes of the maximum memory that will be really allocated (must ideally fit into RAM)
  bSingleThreadUsage | set to TRUE if there will be no concurrent threads that will access the virtual memory mapping. This can optimize performance a bit. If set to FALSE, CPLVirtualMemDeclareThread() must be called.
  papszOptions | NULL terminated list of options. Unused for now.

Returns
  a virtual memory object that must be freed by CPLVirtualMemFree(), or NULL in case of failure.

Since
  GDAL 1.11

CPLVirtualMem* GDALRasterBandGetVirtualMem | ( | GDALRasterBandH | hBand,
|  | GDALRWFlag | eRWFlag,
|  | int | nXOff,
|  | int | nYOff,
|  | int | nXSize,
|  | int | nYSize,
|  | int | nBufXSize,
|  | int | nBufYSize,
|  | GDALDataType | eBufType,
|  | int | nPixelSpace,
|  | GIntBig | nLineSpace,
|  | size_t | nCacheSize,
|  | size_t | nPageSizeHint,
|  | int | bSingleThreadUsage,
|  | char ** | papszOptions
| ) |  |

Create a CPLVirtualMem object from a GDAL raster band object.

Only supported on Linux for now.

This method allows creating a virtual memory object for a region of a GDALRasterBand. The content of the virtual memory object is automatically filled from dataset content when a virtual memory page is first accessed, and it is released (or flushed in case of a "dirty" page) when the cache size limit has been reached.

The pointer to access the virtual memory object is obtained with CPLVirtualMemGetAddr(). It remains valid until CPLVirtualMemFree() is called. CPLVirtualMemFree() must be called before the raster band object is destroyed.

If p is such a pointer and base_type the C type matching eBufType, for values of spacing parameters, the element of image coordinates (x, y) default (relative to xOff, yOff) can be accessed with ((base_type*)p)[x + y * nBufXSize].

Note that the mechanism used to transparently fill memory pages when they are accessed is the same (but in a controlled way) than what occurs when a memory error occurs in a program. Debugging software will generally interrupt program execution when that happens. If needed, CPLVirtualMemPin() can be used to avoid that by ensuring memory pages are allocated before being accessed.

The size of the region that can be mapped as a virtual memory object depends on hardware and operating system limitations. On Linux AMD64 platforms, the maximum value is 128 TB. On Linux x86 platforms, the maximum value is 2 GB.

Data type translation is automatically done if the data type (eBufType) of the buffer is different than that of the GDALRasterBand.

Image decimation / replication is currently not supported, i.e. if the size of the region being accessed (nXSize x nYSize) is different from the buffer size (nBufXSize x nBufYSize).

The nPixelSpace and nLineSpace parameters allow reading into or writing from various organization of buffers. Arbitrary values for the spacing parameters are not supported. Those values must be multiple of the size of the buffer data type and must be such that nLineSpace >= nPixelSpace * nBufXSize.

Parameters

  hBand | Rasterband object
  eRWFlag | Either GF_Read to read a region of data, or GF_Write to write a region of data.
  nXOff | The pixel offset to the top left corner of the region of the band to be accessed. This would be zero to start from the left side.
  nYOff | The line offset to the top left corner of the region of the band to be accessed. This would be zero to start from the top.
  nXSize | The width of the region of the band to be accessed in pixels.
  nYSize | The height of the region of the band to be accessed in lines.
  nBufXSize | the width of the buffer image into which the desired region is to be read, or from which it is to be written.
  nBufYSize | the height of the buffer image into which the desired region is to be read, or from which it is to be written.
  eBufType | the type of the pixel values in the data buffer. The pixel values will automatically be translated to/from the GDALRasterBand data type as needed.
  nPixelSpace | The byte offset from the start of one pixel value in the buffer to the start of the next pixel value within a scanline. If defaulted (0) the size of the datatype eBufType is used.
  nLineSpace | The byte offset from the start of one scanline in the buffer to the start of the next. If defaulted (0) the size of the datatype eBufType * nBufXSize is used.
  nCacheSize | size in bytes of the maximum memory that will be really allocated (must ideally fit into RAM)
  nPageSizeHint | hint for the page size. Must be a multiple of the system page size, returned by CPLGetPageSize(). Minimum value is generally 4096. Might be set to 0 to let the function determine a default page size.
  bSingleThreadUsage | set to TRUE if there will be no concurrent threads that will access the virtual memory mapping. This can optimize performance a bit. If set to FALSE, CPLVirtualMemDeclareThread() must be called.
  papszOptions | NULL terminated list of options. Unused for now.

Returns
  a virtual memory object that must be freed by CPLVirtualMemFree(), or NULL in case of failure.

Since
  GDAL 1.11

CPLErr GDALRasterIO | ( | GDALRasterBandH | hBand,
|  | GDALRWFlag | eRWFlag,
|  | int | nXOff,
|  | int | nYOff,
|  | int | nXSize,
|  | int | nYSize,
|  | void * | pData,
|  | int | nBufXSize,
|  | int | nBufYSize,
|  | GDALDataType | eBufType,
|  | int | nPixelSpace,
|  | int | nLineSpace
| ) |  |

Read/write a region of image data for this band.

Use GDALRasterIOEx() if 64 bit spacings or extra arguments (resampling resolution, progress callback, etc. are needed)

See also
  GDALRasterBand::RasterIO()

CPLErr GDALRasterIOEx | ( | GDALRasterBandH | hBand,
|  | GDALRWFlag | eRWFlag,
|  | int | nXOff,
|  | int | nYOff,
|  | int | nXSize,
|  | int | nYSize,
|  | void * | pData,
|  | int | nBufXSize,
|  | int | nBufYSize,
|  | GDALDataType | eBufType,
|  | GSpacing | nPixelSpace,
|  | GSpacing | nLineSpace,
|  | GDALRasterIOExtraArg * | psExtraArg
| ) |  |

Read/write a region of image data for this band.

See also
  GDALRasterBand::RasterIO()

Since
  GDAL 2.0

int GDALRATChangesAreWrittenToFile | ( | GDALRasterAttributeTableH | hRAT | ) |

Determine whether changes made to this RAT are reflected directly in the dataset.

This function is the same as the C++ method GDALRasterAttributeTable::ChangesAreWrittenToFile()

GDALRasterAttributeTableH GDALRATClone | ( | GDALRasterAttributeTableH | hRAT | ) |

Copy Raster Attribute Table.

This function is the same as the C++ method GDALRasterAttributeTable::Clone()

CPLErr GDALRATCreateColumn | ( | GDALRasterAttributeTableH | hRAT,
|  | const char * | pszFieldName,
|  | GDALRATFieldType | eFieldType,
|  | GDALRATFieldUsage | eFieldUsage
| ) |  |

Create new column.

This function is the same as the C++ method GDALRasterAttributeTable::CreateColumn()

void GDALRATDumpReadable | ( | GDALRasterAttributeTableH | hRAT,
|  | FILE * | fp
| ) |  |

Dump RAT in readable form.

This function is the same as the C++ method GDALRasterAttributeTable::DumpReadable()

int GDALRATGetColOfUsage | ( | GDALRasterAttributeTableH | hRAT,
|  | GDALRATFieldUsage | eUsage
| ) |  |

Fetch column index for given usage.

This function is the same as the C++ method GDALRasterAttributeTable::GetColOfUsage()

int GDALRATGetColumnCount | ( | GDALRasterAttributeTableH | hRAT | ) |

Fetch table column count.

This function is the same as the C++ method GDALRasterAttributeTable::GetColumnCount()

int GDALRATGetLinearBinning | ( | GDALRasterAttributeTableH | hRAT,
|  | double * | pdfRow0Min,
|  | double * | pdfBinSize
| ) |  |

Get linear binning information.

This function is the same as the C++ method GDALRasterAttributeTable::GetLinearBinning()

const char* GDALRATGetNameOfCol | ( | GDALRasterAttributeTableH | hRAT,
|  | int | iCol
| ) |  |

Fetch name of indicated column.

This function is the same as the C++ method GDALRasterAttributeTable::GetNameOfCol()

Parameters

  hRAT | RAT handle.
  iCol | column index.

Returns
  name.

int GDALRATGetRowCount | ( | GDALRasterAttributeTableH | hRAT | ) |

Fetch row count.

This function is the same as the C++ method GDALRasterAttributeTable::GetRowCount()

int GDALRATGetRowOfValue | ( | GDALRasterAttributeTableH | hRAT,
|  | double | dfValue
| ) |  |

Get row for pixel value.

This function is the same as the C++ method GDALRasterAttributeTable::GetRowOfValue()

GDALRATFieldType GDALRATGetTypeOfCol | ( | GDALRasterAttributeTableH | hRAT,
|  | int | iCol
| ) |  |

Fetch column type.

This function is the same as the C++ method GDALRasterAttributeTable::GetTypeOfCol()

Parameters

  hRAT | RAT handle.
  iCol | column index.

Returns
  type.

GDALRATFieldUsage GDALRATGetUsageOfCol | ( | GDALRasterAttributeTableH | hRAT,
|  | int | iCol
| ) |  |

Fetch column usage value.

This function is the same as the C++ method GDALRasterAttributeTable::GetUsageOfCol()

Parameters

  hRAT | RAT handle.
  iCol | column index.

Returns
  usage.

double GDALRATGetValueAsDouble | ( | GDALRasterAttributeTableH | hRAT,
|  | int | iRow,
|  | int | iField
| ) |  |

Fetch field value as a double.

This function is the same as the C++ method GDALRasterAttributeTable::GetValueAsDouble()

int GDALRATGetValueAsInt | ( | GDALRasterAttributeTableH | hRAT,
|  | int | iRow,
|  | int | iField
| ) |  |

Fetch field value as a integer.

This function is the same as the C++ method GDALRasterAttributeTable::GetValueAsInt()

const char* GDALRATGetValueAsString | ( | GDALRasterAttributeTableH | hRAT,
|  | int | iRow,
|  | int | iField
| ) |  |

Fetch field value as a string.

This function is the same as the C++ method GDALRasterAttributeTable::GetValueAsString()

CPLErr GDALRATInitializeFromColorTable | ( | GDALRasterAttributeTableH | hRAT,
|  | GDALColorTableH | hCT
| ) |  |

Initialize from color table.

This function is the same as the C++ method GDALRasterAttributeTable::InitializeFromColorTable()

void* GDALRATSerializeJSON | ( | GDALRasterAttributeTableH | hRAT | ) |

Serialize Raster Attribute Table in Json format.

This function is the same as the C++ method GDALRasterAttributeTable::SerializeJSON()

CPLErr GDALRATSetLinearBinning | ( | GDALRasterAttributeTableH | hRAT,
|  | double | dfRow0Min,
|  | double | dfBinSize
| ) |  |

Set linear binning information.

This function is the same as the C++ method GDALRasterAttributeTable::SetLinearBinning()

void GDALRATSetRowCount | ( | GDALRasterAttributeTableH | hRAT,
|  | int | nNewCount
| ) |  |

Set row count.

This function is the same as the C++ method GDALRasterAttributeTable::SetRowCount()

Parameters

  hRAT | RAT handle.
  nNewCount | the new number of rows.

void GDALRATSetValueAsDouble | ( | GDALRasterAttributeTableH | hRAT,
|  | int | iRow,
|  | int | iField,
|  | double | dfValue
| ) |  |

Set field value from double.

This function is the same as the C++ method GDALRasterAttributeTable::SetValue()

void GDALRATSetValueAsInt | ( | GDALRasterAttributeTableH | hRAT,
|  | int | iRow,
|  | int | iField,
|  | int | nValue
| ) |  |

Set field value from integer.

This function is the same as the C++ method GDALRasterAttributeTable::SetValue()

void GDALRATSetValueAsString | ( | GDALRasterAttributeTableH | hRAT,
|  | int | iRow,
|  | int | iField,
|  | const char * | pszValue
| ) |  |

Set field value from string.

This function is the same as the C++ method GDALRasterAttributeTable::SetValue()

Parameters

  hRAT | RAT handle.
  iRow | row index.
  iField | field index.
  pszValue | value.

GDALColorTableH GDALRATTranslateToColorTable | ( | GDALRasterAttributeTableH | hRAT,
|  | int | nEntryCount
| ) |  |

Translate to a color table.

This function is the same as the C++ method GDALRasterAttributeTable::TranslateToColorTable()

CPLErr GDALRATValuesIOAsDouble | ( | GDALRasterAttributeTableH | hRAT,
|  | GDALRWFlag | eRWFlag,
|  | int | iField,
|  | int | iStartRow,
|  | int | iLength,
|  | double * | pdfData
| ) |  |

Read or Write a block of doubles to/from the Attribute Table.

This function is the same as the C++ method GDALRasterAttributeTable::ValuesIO()

CPLErr GDALRATValuesIOAsInteger | ( | GDALRasterAttributeTableH | hRAT,
|  | GDALRWFlag | eRWFlag,
|  | int | iField,
|  | int | iStartRow,
|  | int | iLength,
|  | int * | pnData
| ) |  |

Read or Write a block of ints to/from the Attribute Table.

This function is the same as the C++ method GDALRasterAttributeTable::ValuesIO()

CPLErr GDALRATValuesIOAsString | ( | GDALRasterAttributeTableH | hRAT,
|  | GDALRWFlag | eRWFlag,
|  | int | iField,
|  | int | iStartRow,
|  | int | iLength,
|  | char ** | papszStrList
| ) |  |

Read or Write a block of strings to/from the Attribute Table.

This function is the same as the C++ method GDALRasterAttributeTable::ValuesIO()

CPLErr GDALReadBlock | ( | GDALRasterBandH | hBand,
|  | int | nXOff,
|  | int | nYOff,
|  | void * | pData
| ) |  |

Read a block of image data efficiently.

See also
  GDALRasterBand::ReadBlock()

int GDALReadOziMapFile | ( | const char * | pszBaseFilename,
|  | double * | padfGeoTransform,
|  | char ** | ppszWKT,
|  | int * | pnGCPCount,
|  | GDAL_GCP ** | ppasGCPs
| ) |  |

Helper function for translator implementer wanting support for OZI .map.

Parameters

  pszBaseFilename | filename whose basename will help building the .map filename.
  padfGeoTransform | output geotransform. Must hold 6 doubles.
  ppszWKT | output pointer to a string that will be allocated with CPLMalloc().
  pnGCPCount | output pointer to GCP count.
  ppasGCPs | outputer pointer to an array of GCPs.

Returns
  TRUE in case of success, FALSE otherwise.

int GDALReadTabFile | ( | const char * | pszBaseFilename,
|  | double * | padfGeoTransform,
|  | char ** | ppszWKT,
|  | int * | pnGCPCount,
|  | GDAL_GCP ** | ppasGCPs
| ) |  |

Helper function for translator implementer wanting support for MapInfo .tab files.

Parameters

  pszBaseFilename | filename whose basename will help building the .tab filename.
  padfGeoTransform | output geotransform. Must hold 6 doubles.
  ppszWKT | output pointer to a string that will be allocated with CPLMalloc().
  pnGCPCount | output pointer to GCP count.
  ppasGCPs | outputer pointer to an array of GCPs.

Returns
  TRUE in case of success, FALSE otherwise.

int GDALReadWorldFile | ( | const char * | pszBaseFilename,
|  | const char * | pszExtension,
|  | double * | padfGeoTransform
| ) |  |

Read ESRI world file.

This function reads an ESRI style world file, and formats a geotransform from its contents. It does the same as GDALLoadWorldFile() function, but it will form the filename for the worldfile from the filename of the raster file referred and the suggested extension. If no extension is provided, the code will internally try the unix style and windows style world file extensions (eg. for .tif these would be .tfw and .tifw).

The world file contains an affine transformation with the parameters in a different order than in a geotransform array.

- geotransform[1] : width of pixel
- geotransform[4] : rotational coefficient, zero for north up images.
- geotransform[2] : rotational coefficient, zero for north up images.
- geotransform[5] : height of pixel (but negative)
- geotransform[0] + 0.5 * geotransform[1] + 0.5 * geotransform[2] : x offset to center of top left pixel.
- geotransform[3] + 0.5 * geotransform[4] + 0.5 * geotransform[5] : y offset to center of top left pixel.

Parameters

  pszBaseFilename | the target raster file.
  pszExtension | the extension to use (i.e. ".wld") or NULL to derive it from the pszBaseFilename
  padfGeoTransform | the six double array into which the geotransformation should be placed.

Returns
  TRUE on success or FALSE on failure.

int GDALReferenceDataset | ( | GDALDatasetH | hDataset | ) |

Add one to dataset reference count.

See also
  GDALDataset::Reference()

CPLErr GDALRegenerateOverviews | ( | GDALRasterBandH | hSrcBand,
|  | int | nOverviewCount,
|  | GDALRasterBandH * | pahOvrBands,
|  | const char * | pszResampling,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressData
| ) |  |

Generate downsampled overviews.

This function will generate one or more overview images from a base image using the requested downsampling algorithm. Its primary use is for generating overviews via GDALDataset::BuildOverviews(), but it can also be used to generate downsampled images in one file from another outside the overview architecture.

The output bands need to exist in advance.

The full set of resampling algorithms is documented in GDALDataset::BuildOverviews().

This function will honour properly NODATA_VALUES tuples (special dataset metadata) so that only a given RGB triplet (in case of a RGB image) will be considered as the nodata value and not each value of the triplet independently per band.

Parameters

  hSrcBand | the source (base level) band.
  nOverviewCount | the number of downsampled bands being generated.
  pahOvrBands | the list of downsampled bands to be generated.
  pszResampling | Resampling algorithm (e.g. "AVERAGE").
  pfnProgress | progress report function.
  pProgressData | progress function callback data.

Returns
  CE_None on success or CE_Failure on failure.

int GDALRegisterDriver | ( | GDALDriverH | hDriver | ) |

Register a driver for use.

See also
  GDALDriverManager::GetRegisterDriver()

int GDALReleaseDataset | ( | GDALDatasetH | hDataset | ) |

Drop a reference to this object, and destroy if no longer referenced.

See also
  GDALDataset::ReleaseRef()

Since
  GDAL 2.2

CPLErr GDALRenameDataset | ( | GDALDriverH | hDriver,
|  | const char * | pszNewName,
|  | const char * | pszOldName
| ) |  |

Rename a dataset.

See also
  GDALDriver::Rename()

void GDALSetCacheMax | ( | int | nNewSizeInBytes | ) |

Set maximum cache memory.

This function sets the maximum amount of memory that GDAL is permitted to use for GDALRasterBlock caching. The unit of the value is bytes.

The maximum value is 2GB, due to the use of a signed 32 bit integer. Use GDALSetCacheMax64() to be able to set a higher value.

Parameters

  nNewSizeInBytes | the maximum number of bytes for caching.

void GDALSetCacheMax64 | ( | GIntBig | nNewSizeInBytes | ) |

Set maximum cache memory.

This function sets the maximum amount of memory that GDAL is permitted to use for GDALRasterBlock caching. The unit of the value is bytes.

Note: On 32 bit platforms, the maximum amount of memory that can be addressed by a process might be 2 GB or 3 GB, depending on the operating system capabilities. This function will not make any attempt to check the consistency of the passed value with the effective capabilities of the OS.

Parameters

  nNewSizeInBytes | the maximum number of bytes for caching.

Since
  GDAL 1.8.0

void GDALSetColorEntry | ( | GDALColorTableH | hTable,
|  | int | i,
|  | const GDALColorEntry * | poEntry
| ) |  |

Set entry in color table.

This function is the same as the C++ method GDALColorTable::SetColorEntry()

CPLErr GDALSetDefaultHistogram | ( | GDALRasterBandH | hBand,
|  | double | dfMin,
|  | double | dfMax,
|  | int | nBuckets,
|  | int * | panHistogram
| ) |  |

Set default histogram.

Use GDALSetRasterHistogramEx() instead to be able to set counts exceeding 2 billion.

See also
  GDALRasterBand::SetDefaultHistogram()
  GDALSetRasterHistogramEx()

CPLErr GDALSetDefaultHistogramEx | ( | GDALRasterBandH | hBand,
|  | double | dfMin,
|  | double | dfMax,
|  | int | nBuckets,
|  | GUIntBig * | panHistogram
| ) |  |

Set default histogram.

See also
  GDALRasterBand::SetDefaultHistogram()

Since
  GDAL 2.0

CPLErr GDALSetDefaultRAT | ( | GDALRasterBandH | hBand,
|  | GDALRasterAttributeTableH | hRAT
| ) |  |

Set default Raster Attribute Table.

See also
  GDALRasterBand::GDALSetDefaultRAT()

void GDALSetDescription | ( | GDALMajorObjectH | hObject,
|  | const char * | pszNewDesc
| ) |  |

Set object description.

See also
  GDALMajorObject::SetDescription()

CPLErr GDALSetGCPs | ( | GDALDatasetH | hDS,
|  | int | nGCPCount,
|  | const GDAL_GCP * | pasGCPList,
|  | const char * | pszGCPProjection
| ) |  |

Assign GCPs.

See also
  GDALDataset::SetGCPs()

CPLErr GDALSetGeoTransform | ( | GDALDatasetH | hDS,
|  | double * | padfTransform
| ) |  |

Set the affine transformation coefficients.

See also
  GDALDataset::SetGeoTransform()

CPLErr GDALSetMetadata | ( | GDALMajorObjectH | hObject,
|  | char ** | papszMD,
|  | const char * | pszDomain
| ) |  |

Set metadata.

CAUTION: when using this function on a GDALDatasetH or GDALRasterBandH, depending on the format, older values of the updated information might still be found in the file in a "ghost" state, even if no longer accessible through the GDAL API. This is for example the case of the GTiff format (this is not a exhaustive list)

See also
  GDALMajorObject::SetMetadata(), GDALDataset::SetMetadata(), GDALRasterBand::SetMetadata()

CPLErr GDALSetMetadataItem | ( | GDALMajorObjectH | hObject,
|  | const char * | pszName,
|  | const char * | pszValue,
|  | const char * | pszDomain
| ) |  |

Set single metadata item.

CAUTION: when using this function on a GDALDatasetH or GDALRasterBandH, depending on the format, older values of the updated information might still be found in the file in a "ghost" state, even if no longer accessible through the GDAL API. This is for example the case of the GTiff format (this is not a exhaustive list)

See also
  GDALMajorObject::SetMetadataItem(), GDALDataset::SetMetadataItem(), GDALRasterBand::SetMetadataItem()

CPLErr GDALSetProjection | ( | GDALDatasetH | hDS,
|  | const char * | pszProjection
| ) |  |

Set the projection reference string for this dataset.

See also
  GDALDataset::SetProjection()

CPLErr GDALSetRasterCategoryNames | ( | GDALRasterBandH | hBand,
|  | char ** | papszNames
| ) |  |

Set the category names for this band.

See also
  GDALRasterBand::SetCategoryNames()

CPLErr GDALSetRasterColorInterpretation | ( | GDALRasterBandH | hBand,
|  | GDALColorInterp | eColorInterp
| ) |  |

Set color interpretation of a band.

See also
  GDALRasterBand::SetColorInterpretation()

CPLErr GDALSetRasterColorTable | ( | GDALRasterBandH | hBand,
|  | GDALColorTableH | hCT
| ) |  |

Set the raster color table.

See also
  GDALRasterBand::SetColorTable()

CPLErr GDALSetRasterNoDataValue | ( | GDALRasterBandH | hBand,
|  | double | dfValue
| ) |  |

Set the no data value for this band.

Depending on drivers, changing the no data value may or may not have an effect on the pixel values of a raster that has just been created. It is thus advised to explicitly called Fill() if the intent is to initialize the raster to the nodata value. In ay case, changing an existing no data value, when one already exists and the dataset exists or has been initialized, has no effect on the pixel whose value matched the previous nodata value.

See also
  GDALRasterBand::SetNoDataValue()

CPLErr GDALSetRasterOffset | ( | GDALRasterBandH | hBand,
|  | double | dfNewOffset
| ) |  |

Set scaling offset.

See also
  GDALRasterBand::SetOffset()

CPLErr GDALSetRasterScale | ( | GDALRasterBandH | hBand,
|  | double | dfNewOffset
| ) |  |

Set scaling ratio.

See also
  GDALRasterBand::SetScale()

CPLErr GDALSetRasterStatistics | ( | GDALRasterBandH | hBand,
|  | double | dfMin,
|  | double | dfMax,
|  | double | dfMean,
|  | double | dfStdDev
| ) |  |

Set statistics on band.

See also
  GDALRasterBand::SetStatistics()

CPLErr GDALSetRasterUnitType | ( | GDALRasterBandH | hBand,
|  | const char * | pszNewValue
| ) |  |

Set unit type.

See also
  GDALRasterBand::SetUnitType()

Since
  GDAL 1.8.0

void GDALSwapWords | ( | void * | pData,
|  | int | nWordSize,
|  | int | nWordCount,
|  | int | nWordSkip
| ) |  |

Byte swap words in-place.

This function will byte swap a set of 2, 4 or 8 byte words "in place" in a memory array. No assumption is made that the words being swapped are word aligned in memory. Use the CPL_LSB and CPL_MSB macros from cpl_port.h to determine if the current platform is big endian or little endian. Use The macros like CPL_SWAP32() to byte swap single values without the overhead of a function call.

Parameters

  pData | pointer to start of data buffer.
  nWordSize | size of words being swapped in bytes. Normally 2, 4 or 8.
  nWordCount | the number of words to be swapped in this call.
  nWordSkip | the byte offset from the start of one word to the start of the next. For packed buffers this is the same as nWordSize.

void GDALSwapWordsEx | ( | void * | pData,
|  | int | nWordSize,
|  | size_t | nWordCount,
|  | int | nWordSkip
| ) |  |

Byte swap words in-place.

This function will byte swap a set of 2, 4 or 8 byte words "in place" in a memory array. No assumption is made that the words being swapped are word aligned in memory. Use the CPL_LSB and CPL_MSB macros from cpl_port.h to determine if the current platform is big endian or little endian. Use The macros like CPL_SWAP32() to byte swap single values without the overhead of a function call.

Parameters

  pData | pointer to start of data buffer.
  nWordSize | size of words being swapped in bytes. Normally 2, 4 or 8.
  nWordCount | the number of words to be swapped in this call.
  nWordSkip | the byte offset from the start of one word to the start of the next. For packed buffers this is the same as nWordSize.

Since
  GDAL 2.1

int GDALValidateCreationOptions | ( | GDALDriverH | hDriver,
|  | char ** | papszCreationOptions
| ) |  |

Validate the list of creation options that are handled by a driver.

This is a helper method primarily used by Create() and CreateCopy() to validate that the passed in list of creation options is compatible with the GDAL_DMD_CREATIONOPTIONLIST metadata item defined by some drivers.

See also
  GDALGetDriverCreationOptionList()

If the GDAL_DMD_CREATIONOPTIONLIST metadata item is not defined, this function will return TRUE. Otherwise it will check that the keys and values in the list of creation options are compatible with the capabilities declared by the GDAL_DMD_CREATIONOPTIONLIST metadata item. In case of incompatibility a (non fatal) warning will be emitted and FALSE will be returned.

Parameters

  hDriver | the handle of the driver with whom the lists of creation option must be validated
  papszCreationOptions | the list of creation options. An array of strings, whose last element is a NULL pointer

Returns
  TRUE if the list of creation options is compatible with the Create() and CreateCopy() method of the driver, FALSE otherwise.

const char* GDALVersionInfo | ( | const char * | pszRequest | ) |

Get runtime version information.

Available pszRequest values:

- "VERSION_NUM": Returns GDAL_VERSION_NUM formatted as a string. i.e. "1170" Note: starting with GDAL 1.10, this string will be longer than 4 characters.
- "RELEASE_DATE": Returns GDAL_RELEASE_DATE formatted as a string. i.e. "20020416".
- "RELEASE_NAME": Returns the GDAL_RELEASE_NAME. ie. "1.1.7"
- "--version": Returns one line version message suitable for use in response to –version requests. i.e. "GDAL 1.1.7, released 2002/04/16"
- "LICENSE": Returns the content of the LICENSE.TXT file from the GDAL_DATA directory. Before GDAL 1.7.0, the returned string was leaking memory but this is now resolved. So the result should not been freed by the caller.
- "BUILD_INFO": List of NAME=VALUE pairs separated by newlines with information on build time options.

Parameters

  pszRequest | the type of version info desired, as listed above.

Returns
  an internal string containing the requested information.

CPLErr GDALWriteBlock | ( | GDALRasterBandH | hBand,
|  | int | nXOff,
|  | int | nYOff,
|  | void * | pData
| ) |  |

Write a block of image data efficiently.

See also
  GDALRasterBand::WriteBlock()

int GDALWriteWorldFile | ( | const char * | pszBaseFilename,
|  | const char * | pszExtension,
|  | double * | padfGeoTransform
| ) |  |

Write ESRI world file.

This function writes an ESRI style world file from the passed geotransform.

The world file contains an affine transformation with the parameters in a different order than in a geotransform array.

- geotransform[1] : width of pixel
- geotransform[4] : rotational coefficient, zero for north up images.
- geotransform[2] : rotational coefficient, zero for north up images.
- geotransform[5] : height of pixel (but negative)
- geotransform[0] + 0.5 * geotransform[1] + 0.5 * geotransform[2] : x offset to center of top left pixel.
- geotransform[3] + 0.5 * geotransform[4] + 0.5 * geotransform[5] : y offset to center of top left pixel.

Parameters

  pszBaseFilename | the target raster file.
  pszExtension | the extension to use (i.e. ".wld"). Must not be NULL
  padfGeoTransform | the six double array from which the geotransformation should be read.

Returns
  TRUE on success or FALSE on failure.

Generated for GDAL by 1.8.9.1.